% This function projects on bounds

function y = ACOPFdynamicSimBounds(x, parConstr)

% Parameters:

%  x         - point to project, it must be a row vector
%  parConstr - cell array with two elements: parConstr{1} is double array with the lower bound ...
%              and parConstr{2} is double array with the upper bound

% modification
%   The function is to find the upper and lower bounds on x based on
%   attempted charing x
% x          - charging policy
% parConstr  - EstMax, Est0

TotEnBatMax = parConstr{1};
TotEnBat0 = parConstr{2};

n=length(x);
%lower
if n > 1
    EstWithout0 = 0;
    for (i=1:n)
        %currentPower = TotEnBatMax-(TotEnBat0+EstWithout0)
        y(i)=max(-(TotEnBat0+EstWithout0),x(i));
        EstWithout0 = EstWithout0 + x(i);
        %y=max(parConstr{1}',x);
    end
else
    y=max(-TotEnBat0,x);
end
n=length(x);
%upper
if n > 1
    EstWithout0 = 0;
     for (i=1:n)
        %currentPower = TotEnBatMax-(TotEnBat0+EstWithout0)
        y(i)=min(TotEnBatMax-(TotEnBat0+EstWithout0),y(i));
        EstWithout0 = EstWithout0 + y(i);
        %y=min(parConstr{2}',y);
     end
else
    y=min(TotEnBatMax-TotEnBat0,y);
end
    
end
