%% Simple 4 bus case as illustration and starting point
%  See fiugre for picture and parameters
%  ----------------------------------------------------
%%
close all
clear
clc

%% Total number of varibles in 1 hour for 4 busses
% 1 theta1
% 2 theta2
% 3 theta3
% 4 theta4
% 5 V_1
% 6 V_2
% 7 V_3
% 8 V_4
% 9  P_1 - Pgen
% 10 P_2 - Pw
% 11 P_3 - Pbat
% 12 P_4 - Pl
% 13 Q_1
% 14 Q_2
% 15 Q_3
% 16 Q_4

n=4;
num_var = 16;

z_12 = 0.01008 + 1i*0.0504;
z_13 = 0.00744 + 1i*0.0372;
z_24 = 0.00744 + 1i*0.0372;
z_34 = 0.01272 + 1i*0.0636;

y_12 = 1/z_12 ;
y_13 = 1/z_13 ;
y_24 = 1/z_24 ;
y_34 = 1/z_34 ;

%Ybus=zeros(n);
Ybus = [y_12+y_13       -y_12           -y_13        0;
          -y_12       y_12+y_24           0        -y_24;
          -y_13           0           y_13+y_34    -y_34;
            0           -y_24           -y_34    y_34+y_24];
%G=real(Ybus);
%B=imag(Ybus);



%[x,fval,exitflag,output,lambda,grad,hessian] = fmincon(fun,x0,A,b,Aeq,beq,lb,ub,nonlcon,options);
Vbase = 230;
Cgen = 50;

fCost = @(x) (x(9)+x(12))^2*Cgen; %Pgen-80

%Aeg*x = beq
%beq = [V1  delta1   P2     Q2      P3     Q3      P4    V4];
beq = [Vbase   0   -170  -105.35  -200  -123.94   318-80   Vbase*1.02].';
% x = [d1   d2  d3  d4  v1  v2  v3  v4  P1  P2  P3  P4  Q1  Q2  Q3  Q4].'
Aeq = [0    0   0   0   1   0   0   0   0   0   0   0   0   0   0   0;
       1    0   0   0   0   0   0   0   0   0   0   0   0   0   0   0;
       0    0   0   0   0   0   0   0   0   1   0   0   0   0   0   0;
       0    0   0   0   0   0   0   0   0   0   0   0   0   1   0   0;
       0    0   0   0   0   0   0   0   0   0   1   0   0   0   0   0;
       0    0   0   0   0   0   0   0   0   0   0   0   0   0   1   0;
       0    0   0   0   0   0   0   0   0   0   0   1   0   0   0   0;
       0    0   0   0   0   0   0   1   0   0   0   0   0   0   0   0];
   
%%b = [Iij,rated * yij] for all 6 lines
%Iij_rated = Vbase*0.6/max(max(abs(Ybus)));
%b = Iij_rated *[abs(Ybus(1,2)) abs(Ybus(1,3)) abs(Ybus(1,4)) abs(Ybus(2,3)) abs(Ybus(2,4)) abs(Ybus(3,4))];
%%A = [Vi  -Vj] for all 6 lines (ish)
% x = [d1   d2  d3  d4  v1  v2  v3  v4  P1  P2  P3  P4  Q1  Q2  Q3  Q4]
% A   = [0    0   0   0   1   -1   0   0   0   0   0   0   0   0   0   0;
%        0    0   0   0   1   0   -1   0   0   0   0   0   0   0   0   0;
%        0    0   0   0   1   0   0   -1   0   0   0   0   0   0   0   0;
%        0    0   0   0   0   1   -1   0   0   0   0   0   0   0   0   0;
%        0    0   0   0   0   1   0   -1   0   0   0   0   0   0   0   0;
%        0    0   0   0   0   0   1   -1   0   0   0   0   0   0   0   0];
   

Vmx = Vbase*1.1;
Vmn = Vbase*0.9;
Pbase = 400;
Pmx = Pbase*1.5;
Pmn  = -Pbase*1.5;
Qbase = 100;
Qmx = Pbase;
Qmn  = -Pbase;
dmn = -pi()/100;
dmx = pi()/100;
%lb & ub given for X
% x = [d1         d2  d3  d4  v1  v2  v3  v4           P1   P2   P3    P4       Q1  Q2  Q3  Q4]
lb =  [-0.0001  dmn dmn dmn Vbase-0.01 Vmn Vmn Vbase*1.02-0.01 Pmn -170-1 -200-1 318-80-1 Qmn -105.35-1 -123.94-1 Qmn].';
ub =  [ 0.0001  dmx dmx dmx Vbase+0.01 Vmx Vmx Vbase*1.02+0.01 Pmx -170+1 -200+1 318-80+1 Qmx -105.35+1 -123.94+1 Qmx].';
%x0 = zeros(num_var,1);

%x0=lb+(ub-lb)/2;
%x0(isnan(x0))=0;
%lb = [];
%ub = [];
%x0 = [0 0 0 0  230 230 230 230 180-50 0 0 318-80 115-30 0 0 181-50].';
x0 = [0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0].';


A = [];
b = [];
nonlcon = @(x)powerflowConst(x,Ybus);

options = optimoptions('fmincon','Display','iter-detailed','MaxIter',1000,'MaxFunEvals',600000,'TolCon',1e-10,'TolX',1e-12);
    
%options = optimoptions('fmincon','Algorithm','sqp','Display','iter-detailed','MaxIter',1000,'MaxFunEvals',600000,'TolCon',1e-10,'TolX',1e-12);
    
tic
[x,fval,exitflag,output,lambda,grad,hessian] = fmincon(fCost,x0,A,b,Aeq,beq,lb,ub,nonlcon,options);
toc
[c, ceq] = powerflowConst(x,Ybus);
ceq
diffAx_b = Aeq*x - beq
x
fval

