function [y] = ProjectPolicy(x,b)
% program to project to hyperplane surface
% so that x(1)>=x(2)>=x(3)>= ... >=x(n-1)>=x(n)

% Parameters:

%  x         - point to project, it must be a row vector
%  b         - double array with two rows: b(1,:) contains upper bound
%              and b(2,:) contains lower bound

%point to xp

%x = [0.2; 0.9; 1; 1; 0.1]; 

%number of x
n = length(x);

if nargin <2
    b = ones(2,n);
    b(2,:) = zeros(1,n);
end

%project to bounds
% do this after?
y=max(b(2,:),x);
y=min(b(1,:),y);


% original

for i=2:n
    
    if i>2 % not for first
        if y(i-1) <= y(i-2) && y(i) > y(i-1)
             y(i) = y(i-1);
        end
    end
    
    if y(i) > y(i-1)
        %make halfway
        y(i) = (y(i)+y(i-1))/2;
        y(i-1) = y(i);
    end

end

%y

end
    
