function [y] = ProjectPolicyThreshold(x,parConstr)
% program to project to hyperplane surface
% so that ht
% x(m)<=x(m+1)<=x(m+2)<= ... <=x(n-1)>=x(n)
% where m is half + 1

% Parameters:

%  x         - point to project, it must be a row vector
%  parConstr - cell array with two elements: parConstr{1} is double array with the lower bound ...
%              and parConstr{2} is double array with the upper bound

%point to xp

%x = [0.2; 0.9; 1; 1; 0.1]; 

%number of x
%x %can use this to see how it projects points...
nXs = length(x);

% if no specified bounds is given it is set to 1 for upper and 0 for lower
if nargin <2
    parConstr{1} = zeros(1,nXs);
    parConstr{2} = ones(2,nXs);
end

%project to bounds
% do this after?
n=size(parConstr{1});
if n(1) > 1
    y=max(parConstr{1}',x);
else
    y=max(parConstr{1},x);
end
n=size(parConstr{2});
if n(1) > 1
    y=min(parConstr{2}',y);
else
    y=min(parConstr{2},y);
end


%old proj on bounds
%y=max(b(2,:),x);
%y=min(b(1,:),y);


% end and reverse
m = round(nXs/2)+1;

yTemp = y;
%process needs to be done on old values

for i=nXs-1:-1:m
    %i
%     if i<n-1 % not for last
%         if y(i+1) <= y(i+2) && y(i) > y(i+1)
%              y(i) = y(i+1);
%         end
%     end
    
    if y(i) > y(i+1)
        
        for k = nXs:-1:i %should maybe find max fist
            if y(i)> y(k) && yTemp(i)> yTemp(k) %chech the earlies one it breaches
            %make halfway
            yTemp(i) = (y(i)+y(k))/2;
            yTemp(k) = y(i);
            %make all points between half way
            for l=k:-1:i
                yTemp(l) = yTemp(i); %or y(k), does not matter.
            end
            end
        end     
    end

end

y = yTemp;


% original
% 
% for i=2:n
%     
%     if i>2 % not for first
%         if y(i-1) <= y(i-2) && y(i) > y(i-1)
%              y(i) = y(i-1);
%         end
%     end
%     
%     if y(i) > y(i-1)
%         %make halfway
%         y(i) = (y(i)+y(i-1))/2;
%         y(i-1) = y(i);
%     end
% 
% end

%y %can use this to see how it projects points...

end
    
