function [y,grad,exitFlag,NewState] = SimulateACOPF_Opt_v02_1B(x,parFun, modeFlag,randFlag, State)

%parFun={T windProjection windMean rRange};

%windProjection = [30   40   20   30];

%x=[Pg_t1  Pg_t2 Pg_t3 Pg_t4];
%x0=[80 90 70 80];
%parConstr = {[50 50 50 50] [110 110 110 110]};


%windProjection = [30];

%x=[Pg];
%x0=[80];
%parConstr = {[50] [110]};


%used to calc g and w_reaised
%windProjection = 30;

    % 1. Inintializing

%persistent Pw_observed
persistent T windProjection windMean rRange TotEnBatMax TotEnBat NumberOfIterations counter % problem data and observations must be persistent

%parameters for the ACOPF solution, to be loaded once
persistent Pd Qd baseMVA bus gen Y branch num_var Econs gencost_inputdata Vmax Vmin Pmax Pmin Qmax Qmin numbus ibus numgen

% the wind generation realizations to be generated when randFlag=1
persistent Pw_observed

 % 1. Initialization
 
 %parFun={windProjection windMean rRange};
%parFun={T windProjection windMean rRange};
if modeFlag == -1
    T = parFun{2};
    windProjection = parFun{3};
    windMean=parFun{4};
    rRange=parFun{5}; 
    TotEnBatMax=parFun{6};
    NumberOfIterations = parFun{7};
    counter = 1;
    
        [Pd, Qd,baseMVA, bus, gen,Y,branch, num_var, Econs, ...
     gencost_inputdata, ...
    Vmax, Vmin, Pmax, Pmin, Qmax, Qmin,...
    numbus, ibus, numgen]=...
        getProblemDataACPOF(parFun{1}); %parFun{1} defines ACOPF case data
        %getProblemDataACPOFA(parFun{1}); %parFun{1} defines ACOPF case data
        
    randFlag=1;
end

 


% generation of new observation of problem parameters

% [SONDRE 01.08] Since when we are running T periods, the whole string of observations
%                should be generate at the same time for all time periods
%                if randFlag=1, I think we need to do this one level above
%                from SimulateACOPF_v0X_1A to SimulateACOPF_Opt_v0X_1A ...

if randFlag == 1  
    %Pw_observed=windMean*(1-rRange)+2*rand*windMean*rRange;
    % need to make these different for all t's, otherwise they all move the
    % same away from the mean
    for t=1:T
        Pw_observed(t)=windMean(t)*(1-rRange)+2*rand*windMean(t)*rRange;
    end
end

    % 2. solving ACOPF

% values = 0;
% for i=1:T
%     %Pw_guess = windProjection
% [ACOPFsolX, fval] = SimulateACOPF_v01(x(i),windProjection(i),Pw_observed);
% values = values +fval;
% end
%values = 0;
%for i=1:T
    %Pw_guess = windProjection
   % Pg = x;
     %%%%%%%%%%% fprintf('SQG run nr %d\n',counter);
      
     % 2.1 For timestep of 1
     
if T ==1 
    ACOPFsolX=0;
    TotEnBat= TotEnBatMax/2;
    [ACOPFsolX, fval,gradACOPF] = SimulateACOPF_v02_1B(x,windProjection,windMean,rRange,...
        Pd, Qd,baseMVA, bus, gen,Y,branch, num_var, Econs, ...
         gencost_inputdata, ...
        Vmax, Vmin, Pmax, Pmin, Qmax, Qmin,...
        numbus, ibus, numgen,...
        TotEnBat, TotEnBatMax,ACOPFsolX,Pw_observed);
    %%%%%%%%%%%%%%grad = gradACOPF(numbus*2+2);
    grad=[];
    %values = values +fval;
    %end
    %x= ACOPFsolX(10);  %stemmer ikke, detter er ikke batteriet brukt, det ble gitt av x forrige!
    %stateVar = ACOPFsolX;
       %%%%%%%%%%%%%%%%%%%%%%%fprintf('SQG run nr %d with Pb of %d gives %d\n',counter,x,fval);
       %fprintf('And returns : %i\n',fval)
    % returning value and other
        % observation of function value

        %
        values=fval;
        
    % 2.2 for 4 timestep       
   
elseif T ==4
    waitbar(counter/(NumberOfIterations)); 
    values = 0;
    ACOPFsolXlast=0;
    grad = zeros(1,T);
    SOC0 = TotEnBatMax/2;
    SOC = [SOC0 x];
    %xValues = x.'
    for i=1:T
    %             if(i ==1)
    %               TotEnBat = TotEnBatMax; 
    %             end
            %Pw_guess = windProjection
        [ACOPFsolX, fval, gradACOPF] = SimulateACOPF_v02_1B(SOC(i+1)-SOC(i),windProjection(i),windMean(i),rRange,...
            Pd, Qd,baseMVA, bus, gen,Y,branch, num_var, Econs, ...
            gencost_inputdata, ...
            Vmax, Vmin, Pmax, Pmin, Qmax, Qmin,...
            numbus, ibus, numgen,...
            TotEnBat, TotEnBatMax,...
            ACOPFsolXlast, Pw_observed(i));
        
        ACOPFsolXlast=ACOPFsolX;
        grad(i) = gradACOPF(numbus*2+1);
        
        if i == T
           RMS_gradP = sqrt(mean(grad.^2));
           grad = grad - RMS_gradP;
           %grad = grad-mean(grad); % This also produces some funny results,
           %they are not scaled according to weighting
        end

        %x(i)
        %i
        %TotEnBat = TotEnBat+x(i)
        values = values + fval;

        %[i x(i)]

    end % T
%fprintf('SQG run nr %d gives Pb of %d \n',counter,x.');
%fprintf('SQG run nr %d \n',counter);
end
   
%    
   y=values;
   
    % obligatory assignments of output parameters
    
        NewState=[];  % state vector is empty  %can I put stateVar here to be returned? Want to plots
        grad=[];      % no gradient is computed
        exitFlag=0;   % normal exit

    counter=counter+1;
end