function [y,grad,exitFlag,NewState] = SimulateACOPF_Opt_v02_pol3(x,parFun, modeFlag,randFlag, State)


%  Pol 3 uses the ProjectPolicyThreshold constraint on Xs
%        and has z reformulated to be Pgen and Est

% 1. Inintializing

%persistent Pw_observed
persistent T windProjection windMean rRange TotEnBatMax TotEnBat NumberOfIterations counter % problem data and observations must be persistent

%parameters for the ACOPF solution, to be loaded once
persistent Pd Qd baseMVA bus gen Y branch num_var Econs gencost_inputdata Vmax Vmin Pmax Pmin Qmax Qmin numbus ibus numgen

% the wind generation realizations to be generated when randFlag=1
persistent Pw_observed z n m

% n is number of x-es & should be odd
% m is the first half rounded up

 % 1. Initialization
 
 %parFun={windProjection windMean rRange};
%parFun={T windProjection windMean rRange};
if modeFlag == -1
    T = parFun{2};
    windProjection = parFun{3};
    windMean=parFun{4};
    rRange=parFun{5}; 
    TotEnBatMax=parFun{6};
    %NumberOfIterations = parFun{7};
    counter = 1;
    
        [Pd, Qd,baseMVA, bus, gen,Y,branch, num_var, Econs, ...
     gencost_inputdata, ...
    Vmax, Vmin, Pmax, Pmin, Qmax, Qmin,...
    numbus, ibus, numgen]=...
        getProblemDataACPOF(parFun{1}); %parFun{1} defines ACOPF case data
        %getProblemDataACPOFA(parFun{1}); %parFun{1} defines ACOPF case data
        
    randFlag=1;
    n = length(x);
    m = round(n/2);
end

 


% generation of new observation of problem parameters

% [SONDRE 01.08] Since when we are running T periods, the whole string of observations
%                should be generate at the same time for all time periods
%                if randFlag=1, I think we need to do this one level above
%                from SimulateACOPF_v0X_1A to SimulateACOPF_Opt_v0X_1A ...

if randFlag == 1  
    %Pw_observed=windMean*(1-rRange)+2*rand*windMean*rRange;
    % need to make these different for all t's, otherwise they all move the
    % same away from the mean
    for t=1:T
        Pw_observed(t)=windMean(t)*(1-rRange)+2*rand*windMean(t)*rRange;
    end
end

    % 2. solving ACOPF


      
     % 2.1 For timestep of 1
     % to do: update this
if T ==1 
    ACOPFsolX=0;
    TotEnBat= TotEnBatMax/2;
    [ACOPFsolX, fval,gradACOPF] = SimulateACOPF_v02_1B(x,windProjection,windMean,rRange,...
        Pd, Qd,baseMVA, bus, gen,Y,branch, num_var, Econs, ...
         gencost_inputdata, ...
        Vmax, Vmin, Pmax, Pmin, Qmax, Qmin,...
        numbus, ibus, numgen,...
        TotEnBat, TotEnBatMax,ACOPFsolX,Pw_observed);
    %%%%%%%%%%%%%%grad = gradACOPF(numbus*2+2);
    grad=[];
    %values = values +fval;
    %end
    %x= ACOPFsolX(10);  %stemmer ikke, detter er ikke batteriet brukt, det ble gitt av x forrige!
    %stateVar = ACOPFsolX;
       %%%%%%%%%%%%%%%%%%%%%%%
       fprintf('SQG run nr %d\n',counter);
       %fprintf('And returns : %i\n',fval)
    % returning value and other
        % observation of function value

        %
        values=fval;
        
    % 2.2 for 4 timestep       
   
elseif T ==4
    %waitbar(counter/(NumberOfIterations)); 
    values = 0;
    ACOPFsolXlast=0;
    grad = zeros(1,T);
    SOC0 = TotEnBatMax/2;
    %SOC = [SOC0 x];
    %xValues = x.'
    for i=1:T
    %             if(i ==1)
    %               TotEnBat = TotEnBatMax; 
    %             end
            
           % plicy [x01 x02 x03 x11 x12]
           %x0 = [40 25 10 17.5 37.5];
           
           % z is Est at end of t-1
           % z_new is the Est one dicides to go to at end of t
           
            if i == 1
                z = SOC0;
                Est_tm1 = SOC0;
            end
            
            
            %x = [40 25 10 17.5 37.5];
            %x = [40 35 25 10 5 15 17.5 25 37.5];
            %z = 45;
            %n = length(x);
            %m=round(n/2); 
            
            % assigment of charge accoridng to threashold for arbirary
            % lenght
            
            % Est_t is the desired energy level to go to for time step t
            % based on the prevoius realization of stochastic given by Pgen
            % minus Est_t of last step
            if z <= x(m+1) % start of vector
                        Est_t = x(1);
            elseif x(m+1) <= z && z < x(n) % between
                for k = m+1:n-1
                    if x(k) <= z && z < x(k+1)
                        Est_t = x(k-m+1);
                    end
                end
            else
                Est_t = x(m);  % end of vector
            end
            %z_new
                        
            
            
            
%             for k = m+1:n
%                 if k == m+1
%                     
%                     end
%                 elseif x(k-1) <= z && z < x(k)
%                     %z_new = x(k-m);
%                     z_new = 2;
%                 else
%                     %z_new = x(m);
%                     z_new = 3;
%                 end
%             end
%             
            
           
                
               
            %original 
%             if z <= x(4)
%                 z_new = x(1);
%             elseif  x(4) <= z && z < x(5)
%                 z_new = x(2);
%             else
%                 z_new = x(3);
%             end
                
                
        [ACOPFsolX, fval, gradACOPF] = SimulateACOPF_v02_1B(Est_t-Est_tm1,windProjection(i),windMean(i),rRange,...
            Pd, Qd,baseMVA, bus, gen,Y,branch, num_var, Econs, ...
            gencost_inputdata, ...
            Vmax, Vmin, Pmax, Pmin, Qmax, Qmin,...
            numbus, ibus, numgen,...
            TotEnBat, TotEnBatMax,...
            ACOPFsolXlast, Pw_observed(i));
        
        %z = z_new;
        z = ACOPFsolX(numbus*2+1) - Est_t;
        Est_tm1 = Est_t;
        
        ACOPFsolXlast=ACOPFsolX;
        %grad(i) = gradACOPF(numbus*2+1);
        
%         if i == T
%            RMS_gradP = sqrt(mean(grad.^2));
%            grad = grad - RMS_gradP;
%            %grad = grad-mean(grad); % This also produces some funny results,
%            %they are not scaled according to weighting
%         end

        values = values + fval;

        %[i x(i)]

    end % T
    fprintf('SQG run nr %d\n',counter);

end
   
%    
   y=values;
   
    % obligatory assignments of output parameters
    
        NewState=[];  % state vector is empty  %can I put stateVar here to be returned? Want to plots
        grad=[];      % no gradient is computed
        exitFlag=0;   % normal exit

    counter=counter+1;
end