function [x, fval, grad] = SimulateACOPF_v02_1A(Pg_feed,windProjection,windMean,rRange,...
    Pd, Qd,baseMVA, bus, gen,Y,branch, num_var, Econs, ...
     gencost_inputdata, ...
    Vmax, Vmin, Pmax, Pmin, Qmax, Qmin,...
    numbus, ibus, numgen,...
    TotEnBat, TotEnBatMax,...
    ACOPFsolX,Pw_observed)

%ACOPFsolX,randFlag)

% persistent Pw_observed

%[ACOPFsolX, fval] = SimulateACOPF_v01(x(i),windProjection(i),Pw_observed);
% obs dette blir feil. Y er verdiene ut. x er generatoreen. Dvs regner ut
% X0 basert p? forventet vind xsi, og lar vind funsjoenn occillere rund
% forventet wind. 

% NOTHING NEW HERE

% Simple 4 bus case as illustration and starting point
%  See fiugre for picture and parameters
%  ----------------------------------------------------    
    
    % calculate bounds due to limits for generator Pgen, Qgen, and bus V
    %ok to set varible. But to remove, i need to update Aqe etc
    delta_limits_upper = zeros(num_var,1);
    delta_limits_lower = zeros(num_var,1);
    delta_limits_upper(1)=0;
    delta_limits_lower(1)=0;
    for i=2:numbus
        delta_limits_upper(i)=pi;
        delta_limits_lower(i)=-pi;
    end
    
    
    for i=numbus+1:2*numbus
        delta_limits_upper(i,1) = (Vmax(ibus));
        delta_limits_lower(i,1) = (Vmin(ibus));
    end    
    
        
    
    
    for igen = 2*numbus+1:numgen+2*numbus
        delta_limits_upper(igen) = Pmax(igen-2*numbus) ;
        delta_limits_lower(igen) = Pmin(igen-2*numbus) ;
        delta_limits_upper(igen+numgen) = Qmax(igen-2*numbus) ;
        delta_limits_lower(igen+numgen) = Qmin(igen-2*numbus);
    end
    
 

    
    Lb=delta_limits_lower;
    Ub=delta_limits_upper;
    %to use last solution as initial guess...
    if ACOPFsolX == 0
        x0=Lb+(Ub-Lb)/2;
    else
        %ACOPFsolX
        x0=min(Ub,ACOPFsolX);
        x0=max(Lb,ACOPFsolX);
    end
    %back to old
    x0(isnan(x0))=0;
%

% Linear Equality matrix which are Storage equations
%SOC0=0.5*Pmax(3);


  beq=zeros(size(Pd,2),1);
  %beq(1)=SOC0;
  Aeq=zeros(size(Pd,2),size(Pd,2)*num_var);
  Aeq_s=zeros(1,2*num_var);
  %Aeq(1,21) =  1;
  %Aeq(1,num_var*size(Pd,2)-1) =  1;
  %Aeq(1,25) = -0.85;
  %Aeq(1,26) = +0.95;
  
  %Aeq_s(1,47) =  1;
  %Aeq_s(1,21) = -1;
  
  % charge and discharge efficiencies
  %Aeq_s(1,51) = -0.85;
  %Aeq_s(1,52) =  0.95;

  
  j=1; 
     for i=2:size(Pd,2)
        
        
        Aeq(i,j:i*num_var) = Aeq_s;
        j=j+num_var;
       
    end
    

 
 % Putting in data to SQG


%Pw_guess,Pw_observed)
Pw_guess=windProjection; %not used

% [ALEXEI 28.07] !!!!!!!!!!!!!! New observation. Attentiuon to the use of randFlag
% [SONDRE 01.08] Since when we are running T periods, the whole string of observations
%                should be generate at the same time for all time periods
%                if randFlag=1, I think we need to do this one level above
%                from SimulateACOPF_v0X_1A to SimulateACOPF_Opt_v0X_1A ...
%                
% 
% if randFlag == 1
%     Pw_observed=windMean*(1-rRange)+2*rand*windMean*rRange;
% end


%Pw is observation of wind energy
%Pw = Pw_observed;
gen(3,2) = Pw_observed;
gen(3,9) = Pw_observed;
gen(3,10) = Pw_observed;
Lb(11) = (Pw_observed)/baseMVA;
Ub(11) = (Pw_observed)/baseMVA;
x0(11) = Pw_observed/baseMVA;
%realisedVar = Pw_observed;

%Qw = 0;
% loads Pl  Ql
%Pl = Pd(4);
%Pl = Pload(4);
%Ql = -20;
%bat, decided from guess of wind
Pd(2) = Pg_feed;
%Pd(2)
%Pload
%Qb = -Ql-Qw-Qg_leastcost;
%Qb = 0;

%not in use, must be constraint on x of SQG method
% if (Lb(10)<(TotEnBat-TotEnBatMax))
% Lb(10) = TotEnBat-TotEnBatMax;
% end
% if(Ub(10)>TotEnBat)
% Ub(10) = TotEnBat;
% end
% x0(10) = (Lb(10)+Ub(10))/2;

% P_1 - Pgen, P_2 - Pw, P_3 - Pbat, P_4 - Pl



 
 
 
 % Run the Main section
 %
 % Non-linear Equality and inequality Constrains
 ineq=@(x)nonLinConACOPFgeneral(x, Pd, Qd,baseMVA, bus, gen,Y,branch, num_var, Econs);
%ineq=@(x)nonLinConACOPFgeneral(x, Pd, Qd,baseMVA, bus, gen,Y,branch, num_var);

%
% Objective function
fCost=@(x)ACOPFgeneralObjectFun(x, numbus, gencost_inputdata, baseMVA);
%
%Set Fmincon options
% % % % options = optimoptions('fmincon','Display','iter-detailed','MaxIter',300,...
% % % %     'MaxFunEvals',600000,'TolCon',1e-10,'TolX',1e-12);

options = optimoptions('fmincon','Display','none','MaxIter',300,...
    'MaxFunEvals',600000,'TolCon',1e-7,'TolX',1e-7);

% options = optimoptions('fmincon','Display','none','MaxIter',300,...
%     'MaxFunEvals',600000,'TolCon',1e-10,'TolX',1e-12);

% options = optimoptions('fmincon','Display','final','MaxIter',300,...
%     'MaxFunEvals',600000,'TolCon',1e-10,'TolX',1e-12);
%tic
%%%%%%startTime = toc;
[x_new,fval,exitflag,output,lambda,grad,hessian] = fmincon(fCost,x0,[],[],Aeq,beq,Lb,Ub,ineq,options);
%%%%%%%%%%%runTime = toc-startTime
%toc
%gradACOPFX = grad.'
x = x_new;
%fval
%newXvar = x.'

%
% fval
% [ineq, ceq]= nonLinConACOPFgeneral(x_new,Pd,Qd,baseMVA, bus, gen,bus,branch, num_var, Econs)
% 


end
