function [x, fval, grad, realisedVar] = SimulateACOPF_v03(Pg_feed,rRange,...
    Pd, Qd, Pg, Qg,baseMVA, bus, gen,Y,branch, num_var, Econs, ...
     gencost_inputdata, ...
    Vmax, Vmin, Pmax, Pmin, Qmax, Qmin,...
    numbus, ibus, numgen,...
    ACOPFsolX, plotResults,...
    Pw_observed, Ppv_observed,randBusiness,randHouse)
% no Q generated...
%% Simulation of AC-OPF for 24 for a 9 bus case 
%  See fiugre for picture and parameters
%  ----------------------------------------------------

%% Total number of varibles in 1 hour for 9 busses
% 1 theta1
% ...
% 9 theta9
% 10 V_1
% ...
% 18 V_9
% 19 P_1
% ...
% 27 P_9
% 28 Q_1
% ...
% 36 Q_9

    %num_var = 36;
    
    
    %f = zeros(num_var,1);
    %f2= zeros(num_var,1);

    
             
    
    %% calculate general bounds due to limits for generator Pgen, Qgen, and bus V
    %ok to set varible. But to remove, i need to update Aqe etc
    delta_limits_upper = zeros(num_var,1);
    delta_limits_lower = zeros(num_var,1);
    delta_limits_upper(1)=0;
    delta_limits_lower(1)=0;
    for i=2:numbus
        delta_limits_upper(i)=pi;
        delta_limits_lower(i)=-pi;
    end
    
    
    for i=numbus+1:2*numbus
        delta_limits_upper(i,1) = (Vmax(ibus));
        delta_limits_lower(i,1) = (Vmin(ibus));
    end    
    
        
    
    
    for igen = 2*numbus+1:2*numbus+numgen
        delta_limits_upper(igen) = Pmax(igen-2*numbus) ;
        delta_limits_lower(igen) = Pmin(igen-2*numbus) ;
        delta_limits_upper(igen+numbus) = Qmax(igen-2*numbus) ;
        delta_limits_lower(igen+numbus) = Qmin(igen-2*numbus);
    end
     %delta_limits_lower(28) = 0.50;

    
    Lb=delta_limits_lower;
    Ub=delta_limits_upper;
    %length(Ub)
%    x0=Lb+(Ub-Lb)/2;
        %to use last solution as initial guess...
        %ACOPFsolX
    if ACOPFsolX == 0
        x0=Lb+(Ub-Lb)/2;
    else
        %ACOPFsolX
        %length(ACOPFsolX)
        x0=min(Ub,ACOPFsolX);
        x0=max(Lb,ACOPFsolX);
    end
    %back to old
    x0(isnan(x0))=0;
    
%%

%% Linear Equality matrix which are Storage equations - not used
%SOC0=0.5*Pmax(3);


  %beq=zeros(size(Pd,2),1);
  %beq(1)=SOC0;
  %Aeq=zeros(size(Pd,2),size(Pd,2)*num_var);
  %Aeq_s=zeros(1,2*num_var);
  %Aeq(1,21) =  1;
  %Aeq(1,num_var*size(Pd,2)-1) =  1;
  %Aeq(1,25) = -0.85;
  %Aeq(1,26) = +0.95;
  
  %Aeq_s(1,47) =  1;
  %Aeq_s(1,21) = -1;
  
  % charge and discharge efficiencies
  %Aeq_s(1,51) = -0.85;
  %Aeq_s(1,52) =  0.95;

  
%   j=1; 
%      for i=2:size(Pd,2)
%         
%         
%         Aeq(i,j:i*num_var) = Aeq_s;
%         j=j+num_var;
%        
%     end
%     

 
 %% Updating data for the current time step

 realisedVar = zeros(1,numbus);
%Busses 
% 1 Slack
iWind = 2;% 2 Wind
iPV = 3;% 3 PV

iBusiness = 5;% 5 Business

iHouse = 7;% 7 House

iBattery = 9;% 9 Battery

% generating wind energy for the time step
 
%Pw_guess,Pw_observed)
%Pw_guess=windProjection; %not used
%Pw_observed=windMean*(1-rRange)+2*rand*windMean*rRange
%--->Pw_observed=Pg(iWind)*(1-rRange(iWind))+2*rand*Pg(iWind)*rRange(iWind);
%Pw is observation of wind energy
%Pw = Pw_observed;
gen(iWind,2) = Pw_observed;
gen(iWind,9) = Pw_observed;
gen(iWind,10) = Pw_observed;
Lb(18+iWind) = Pw_observed/baseMVA;
Ub(18+iWind) = Pw_observed/baseMVA;
x0(18+iWind) = Pw_observed/baseMVA;

realisedVar(iWind) = Pw_observed;

% % generating PV energy for the time step
%  
% if Pg(iPV) < 0.0001
%     Ppv_observed = 0;
% else
%     Ppv_observed=Pg(iPV)*(1-rRange(iPV))+2*rand*Pg(iPV)*rRange(iPV);
% end

%Ppv is observation of wind energy
%Pw = Pw_observed;
gen(iPV,2) = Ppv_observed;
gen(iPV,9) = Ppv_observed;
gen(iPV,10) = Ppv_observed;
Lb(18+iPV) = Ppv_observed/baseMVA;
Ub(18+iPV) = Ppv_observed/baseMVA;
x0(18+iPV) = Ppv_observed/baseMVA;

realisedVar(iPV) = Ppv_observed;

% generating load from house and business, make P and Q scale

%randBusiness = rand;
Pd(iBusiness) = Pd(iBusiness)*(1-rRange(iBusiness))+2*randBusiness*Pd(iBusiness)*rRange(iBusiness);
Qd(iBusiness) = Qd(iBusiness)*(1-rRange(iBusiness))+2*randBusiness*Qd(iBusiness)*rRange(iBusiness);
realisedVar(iBusiness) = Pd(iBusiness);
realisedVar(iBusiness+1) = Qd(iBusiness);

%randHouse = rand;
Pd(iHouse) = Pd(iHouse)*(1-rRange(iHouse))+2*randHouse*Pd(iHouse)*rRange(iHouse);
Qd(iHouse) = Qd(iHouse)*(1-rRange(iHouse))+2*randHouse*Qd(iHouse)*rRange(iHouse);
realisedVar(iHouse) = Pd(iHouse);
realisedVar(iHouse+1) = Qd(iHouse);

% putting in x from SQG

%Qw = 0;
% loads Pl  Ql
%Pl = Pd(4);
%Pl = Pload(4);
%Ql = -20;
%bat, decided from guess of wind
Pd(iBattery) = Pg_feed;
realisedVar(iBattery) = Pd(iBattery);
%Pload
%Qb = -Ql-Qw-Qg_leastcost;
%Qb = 0;

%not in use, must be constraint on x of SQG method
% if (Lb(10)<(TotEnBat-TotEnBatMax))
% Lb(10) = TotEnBat-TotEnBatMax;
% end
% if(Ub(10)>TotEnBat)
% Ub(10) = TotEnBat;
% end
% x0(10) = (Lb(10)+Ub(10))/2;

% P_1 - Pgen, P_2 - Pw, P_3 - Pbat, P_4 - Pl



 
 %Pd 
 %Qd
 
 %% Run the Main section
 %%
 % Non-linear Equality and inequality Constrains
 ineq=@(x)nonLinConACOPFgeneral(x, Pd, Qd,baseMVA, bus, gen,Y,branch, num_var, Econs);
%ineq=@(x)nonLinConACOPFgeneral(x, Pd, Qd,baseMVA, bus, gen,Y,branch, num_var);

%%
% Objective function
fCost=@(x)ACOPFgeneralObjectFun(x, numbus, gencost_inputdata, baseMVA);
%fCost=@(x)0;
%%

if plotResults == 0
%Set Fmincon options
options = optimoptions('fmincon','Display','iter-detailed','MaxIter',300,...
    'MaxFunEvals',600000,'TolCon',1e-10,'TolX',1e-12);

% options = optimoptions('fmincon','Display','final','MaxIter',300,...
%     'MaxFunEvals',600000,'TolCon',1e-10,'TolX',1e-12);

%test new x0 for state later maybe
%x0 = [0 0.0191324963586752 -0.0719178199178568 -0.0551332674536833 -0.145362796482200 -0.0947439138089524 -0.0996419764613110 -0.0400382010339170 -0.0557446906888753 1.00000000162093 1.08976171090962 1.08579236529278 1.03475493726070 1.02906632288261 1.08607529221812 1.08147150014056 1.09167221918627 1.06748213031940 0.989939639225490 1.12563352965283 0.459306917848311 0 0 0 0 0 0 -0.576088082175332 0 0 0 0 0 0 0 0].';

%tic
startTime = toc;
[x_new,fval,exitflag,output,lambda,grad,hessian] = fmincon(fCost,x0,[],[],[],[],Lb,Ub,ineq,options);
%grad
runTime = toc-startTime
%toc

%bounds = [Lb Ub];

x = x_new.'
else
options = optimoptions('fmincon','Display','off','MaxIter',300,...
    'MaxFunEvals',600000,'TolCon',1e-10,'TolX',1e-12);
%x0 = [0 0.0191324963586752 -0.0719178199178568 -0.0551332674536833 -0.145362796482200 -0.0947439138089524 -0.0996419764613110 -0.0400382010339170 -0.0557446906888753 1.00000000162093 1.08976171090962 1.08579236529278 1.03475493726070 1.02906632288261 1.08607529221812 1.08147150014056 1.09167221918627 1.06748213031940 0.989939639225490 1.12563352965283 0.459306917848311 0 0 0 0 0 0 -0.576088082175332 0 0 0 0 0 0 0 0].';
[x_new,fval,exitflag,output,lambda,grad,hessian] = fmincon(fCost,x0,[],[],[],[],Lb,Ub,ineq,options);
x = x_new.';    
%grad
end
% lambda
% grad
% hessian

%%
% fval
%[ineq, ceq]= nonLinConACOPFgeneral(x_new,Pd,Qd,baseMVA, bus, gen,bus,branch, num_var, Econs)
% 
% % Objective function -temp4

% 
% %%  x_new is result
%     %update control variable values
% % 1 theta1
% % 2 theta2
% % 3 theta3
% % 4 theta4
% % 5 V_1
% % 6 V_2
% % 7 V_3
% % 8 V_4
% % 9 P_1
% % 10 P_2
% % 11 P_3
% % 12 P_4
% % 13 Q_1
% % 14 Q_2
% % 15 Q_3
% % 16 Q_4
% 
% %     gen1      = zeros(1,length(x_new)/num_var);
% %     gen2      = zeros(1,length(x_new)/num_var);
% %     gen3      = zeros(1,length(x_new)/num_var);
% %     gen4      = zeros(1,length(x_new)/num_var);
% %     Ploa1     = zeros(1,length(x_new)/num_var);
% %     Ploa2     = zeros(1,length(x_new)/num_var);
% %     Ploa3     = zeros(1,length(x_new)/num_var);
% %     Ploa4     = zeros(1,length(x_new)/num_var);
%     
% %     Pgen1      = x_new(9)*baseMVA;
% %     Pgen2      = x_new(10)*baseMVA;
% %     Pgen3      = x_new(11)*baseMVA;
% %     Pgen4      = x_new(12)*baseMVA;
%     
%     %% ----- evaluate constraints -----
%     %first display resulting V and angle
%     v_out = x_new(5:8)*baseKV
%     angle_out = x_new(1:4)*(pi/180)
%      
% %     %evaluate
% %     Vm_out = x_new(5:8);
% %     Va_out = x_new(1:4);
% %     
% %     % reconstruct V
% %     V = Vm_out .* exp(1j * Va_out);
% %     % evaluate power flow equations
% %     [Ybus, Yf, Yt] = makeYbus(baseMVA, bus, branch);
% %     Sbus = makeSbus(baseMVA, bus, gen)
% %     %resulteing injections
% %     S = V .* conj(Ybus * V)*baseMVA
%     %diff is ceq
%     DiffPowerFlow = [ceq(1:4) ceq(5:8)]*baseMVA
% %% Find generated power
%     Pgen      = x_new(9:12)*baseMVA;
%     Qgen      = x_new(13:16)*baseMVA;
%     
% %     Ploa1     = Pd(1);
% %     Ploa2     = Pd(2);
% %     Ploa3     = Pd(3);
% %     Ploa4     = Pd(4);
%     
% %     
% %     for i=1:length(x_new)/num_var
% %         State_ofC(i)= x_new(21+(i-1)*26)*baseMVA;
% %         gen1(i)=x_new(19+(i-1)*26)*baseMVA;
% %         gen2(i)=x_new(20+(i-1)*26)*baseMVA;
% %         charge(i)=x_new(25+(i-1)*26)*baseMVA;
% %         discharge(i)=x_new(26+(i-1)*26)*baseMVA;
% %         Ploa1(i)=Pd(5,i);
% %         Ploa2(i)=Pd(7,i);
% %         Ploa3(i)=Pd(9,i);
% %     end
% 
% figure('Name','Generator results','Numbertitle','off');
% c_gen = categorical({'gen1','gen2','gen3','gen4'});
% gen_vals = [Pgen Qgen]
% bar(c_gen,gen_vals);
% xlabel('Generator')
% ylabel('Generated power')
% legend('Active power, P [MW]','Reactive power, Q [MVAr]')
% title('Results for the generators')
% 
% figure('Name','Load demand','Numbertitle','off');
% % c_load = categorical({'P1','P2','P3','P4'});
% % Ploads = [Ploa1 Ploa2 Ploa3 Ploa4]
% c_load = categorical({'1','2','3','4'});
% Ploads = [Pd Qd]
% bar(c_load,Ploads)
% xlabel('Bus number')
% ylabel('Load values')
% legend('Active power, P [MW]','Reactive power, Q [MVAr]')
% title('Demand for the bus loads')


%% Total number of varibles in 1 hour for 4 busses
% % 1 theta1
% % 2 theta2
% % 3 theta3
% % 4 theta4
% % 5 V_1
% % 6 V_2
% % 7 V_3
% % 8 V_4
% % 9  P_1 - Pgen
% % 10 P_2 - Pw
% % 11 P_3 - Pbat
% % 12 P_4 - Pl
% % 13 Q_1
% % 14 Q_2
% % 15 Q_3
% % 16 Q_4
% 
% n=4;
% num_var = 16;
% 
% z_w = 0.5 + 1i*0.3;
% z_g = 0.3 + 1i*0.2;
% z_bl = 0.2 + 1i*0.1;
% 
% y_w = 1/z_w ;
% y_g = 1/z_g ;
% y_bl = 1/z_bl ;
% 
% %Ybus=zeros(n);
% Ybus = [y_g+y_g+y_w     -y_w            -y_g        -y_g;
%         -y_w            y_w+y_w+y_w     -y_w        -y_w;
%         -y_g            -y_w       y_g+y_w+y_bl     -y_bl;
%         -y_g            -y_w            -y_bl       y_g+y_w+y_bl];
% %G=real(Ybus);
% %B=imag(Ybus);
% 
% 
% 
% %[x,fval,exitflag,output,lambda,grad,hessian] = fmincon(fun,x0,A,b,Aeq,beq,lb,ub,nonlcon,options);
% Vbase = 10;
% Cgen = 50;
% 
% %least cost pgen
% Pg_leastcost = 80;
% Qg_leastcost = 20;
% 
% %cost function; deviation from Pg_least
% fCost = @(x) (x(9)-Pg_leastcost)^2*Cgen; %Pgen-80
% 
% 
% %Pw_guess,Pw_observed)
% Pw_guess=windProjection;
% Pw_observed=windMean*(1-rRange)+2*rand*windMean*rRange;
% %Pw is observation of wind energy
% Pw = Pw_observed;
% Qw = 0;
% % loads Pl  Ql
% Pl = -100;
% Ql = -20;
% %bat, decided from guess of wind
% Pb = -Pl-Pw_guess-Pg_feed;
% %Qb = -Ql-Qw-Qg_leastcost;
% Qb = 0;
% 
% % P_1 - Pgen, P_2 - Pw, P_3 - Pbat, P_4 - Pl
% %Aeg*x = beq
% %beq = [V1  delta1  Pl  Ql  Pw  Qw  Pb  Vb];
% %beq = [Vbase 0      Pl  Ql  Pw  Qw  Pb Vbase].';
% beq = [Vbase 0      Pl  Ql  Pw  Qw  Pb Qb].';
% % x = [d1   d2  d3  d4  v1  v2  v3  v4  P1  P2  P3  P4  Q1  Q2  Q3  Q4]
% Aeq = [0    0   0   0   1   0   0   0   0   0   0   0   0   0   0   0;
%        1    0   0   0   0   0   0   0   0   0   0   0   0   0   0   0;
%        0    0   0   0   0   0   0   0   0   0   0   1   0   0   0   0;
%        0    0   0   0   0   0   0   0   0   0   0   0   0   0   0   1;
%        0    0   0   0   0   0   0   0   0   1   0   0   0   0   0   0;
%        0    0   0   0   0   0   0   0   0   0   0   0   0   1   0   0;
%        0    0   0   0   0   0   0   0   0   0   1   0   0   0   0   0;
%        0    0   0   0   0   0   0   0   0   0   0   0   0   0   1   0];
% %  beq = []; 
% %  Aeq = [];
% 
% %%b = [Iij,rated * yij] for all 6 lines
% %Iij_rated = Vbase*0.6/max(max(abs(Ybus)));
% %b = Iij_rated *[abs(Ybus(1,2)) abs(Ybus(1,3)) abs(Ybus(1,4)) abs(Ybus(2,3)) abs(Ybus(2,4)) abs(Ybus(3,4))];
% %%A = [Vi  -Vj] for all 6 lines (ish)
% % x = [d1   d2  d3  d4  v1  v2  v3  v4  P1  P2  P3  P4  Q1  Q2  Q3  Q4]
% % A   = [0    0   0   0   1   -1   0   0   0   0   0   0   0   0   0   0;
% %        0    0   0   0   1   0   -1   0   0   0   0   0   0   0   0   0;
% %        0    0   0   0   1   0   0   -1   0   0   0   0   0   0   0   0;
% %        0    0   0   0   0   1   -1   0   0   0   0   0   0   0   0   0;
% %        0    0   0   0   0   1   0   -1   0   0   0   0   0   0   0   0;
% %        0    0   0   0   0   0   1   -1   0   0   0   0   0   0   0   0];
%    
% 
% Vmx = Vbase*1.1;
% Vmn = Vbase*0.9;
% Pbase = 100;
% Pg_mx = -Pw-Pl-Pb+15;
% Pg_mn  = -Pw-Pl-Pb;
% %Pg_mx = Pg_feed;
% %Pg_mn  = Pg_feed;
% Qg_mx = -Qw-Ql-Qb+30;
% Qg_mn = -Qw-Ql-Qb;
% dmn = -pi()/2;
% dmx = pi()/2;
% 
% % P_1 - Pgen, P_2 - Pw, P_3 - Pbat, P_4 - Pl
% %lb & ub given for X
% % x = [d1   d2  d3  d4  v1  v2  v3  v4  P1    P2  P3  P4  Q1  Q2  Q3 'Q4]
% lb =  [0  dmn dmn dmn Vbase Vmn Vmn Vmn Pg_mn Pw  Pb  Pl  Qg_mn Qw Qb Ql].';
% ub =  [0  dmx dmx dmx Vbase Vmx Vmx Vmx Pg_mx Pw  Pb  Pl  Qg_mx Qw Qb Ql].';
% %x0 = zeros(num_var,1);
% 
% x0=lb+(ub-lb)/2;
%x0(isnan(x0))=0;
%lb = [];
%ub = [];
%x0 = [0 0 0 0  10 10 10 10 80 30 -10 -100 20 0 0 -20].';

% 
% 
% A = [];
% b = [];
% nonlcon = @(x)powerflowConst(x,Ybus);
% 
% 
% 
% %options = optimoptions('fmincon','Display','iter-detailed','MaxIter',500,'MaxFunEvals',600000,'TolCon',1e-10,'TolX',1e-12);
% 
% %options = optimoptions('fmincon','Algorithm','sqp','Display','iter-detailed','MaxIter',1000,'MaxFunEvals',600000,'TolCon',1e-10,'TolX',1e-12);
% 
% %tic
% [x,fval,exitflag,output,lambda,grad,hessian] = fmincon(fCost,x0,A,b,Aeq,beq,lb,ub,nonlcon,options);
% % toc
% % diffAx_b = Aeq*x - beq
% % [c, ceq] = powerflowConst(x,Ybus);
% % ceq
% % x
% % fval
% % MW = x(9:12)
% % MVAr = x(13:16)
% 


end
