function [xOut, values, SOC, fval, charging, ACOPFsolXMap] = TryACOPFwSDPv01(RealizedWind,SOC0)
close all
clear
%% Load power system data
% 4 bus case

[Pd, Qd,baseMVA, bus, gen,Y,branch, num_var, Econs, ...
     gencost_inputdata, ...
    Vmax, Vmin, Pmax, Pmin, Qmax, Qmin,...
    numbus, ibus, numgen]=...
        getProblemDataACPOF(1);

%% Initialization 
T = 4;
Nsoc = 11;
Nprodw = 11;

cost_to_go = inf(Nsoc,T,Nprodw);
transitionCost = inf(Nsoc,Nprodw);
path = ones(Nsoc,T,Nprodw);

%for final stages = 0 ???? or . . . . . 
cost_to_go(:,T,:) = 0;
transitionCost(Nsoc,:) = 0;
% for soc=1:Nsoc
%     for prodw=1:Nprodw
%         [ACOPFsolXlast, fval, grad] = SimulateACOPF_v02(legalSOCs(t+1,soc_tp1)-legalSOCs(t,soc_t),windProjection,windProduction(prodW_t),rRange,...
%                         Pd, Qd,baseMVA, bus, gen,Y,branch, num_var, Econs, ...
%                         gencost_inputdata, ...
%                         Vmax, Vmin, Pmax, Pmin, Qmax, Qmin,...
%                         numbus, ibus, numgen,...
%                         TotEnBat0, TotEnBatMax,...
%                         ACOPFsolX);
%         cost_to_go(soc,T,prodw)
%         transitionCost(soc,prodw) = fval
%         
% [min_cost, min_soc] = min(transitionCost(:,prodW_t));
%                         cost_to_go(soc_t,t,prodW_t) = min_cost;


TotEnBatMax = 50;
TotEnBat0 = TotEnBatMax/2;

legalSOCs = ones(T,1)*[0:(TotEnBatMax/(Nsoc-1)):TotEnBatMax];

%Which ACOPF case?
ACOPFcase = 1; % 4BusCase
%numbus = 4;
% 
% TotEnBatMax = 50; 
%TotEnBat0 = TotEnBatMax/2;
% 
% %How may timesteps?
% T=4; %1,4




% x tries to find how much battery to store
%x0=80+windMean-100;

ACOPFsolX = 0;
rRange = 0;

%% Making impromptu transition matriz
transition_matrix=zeros(Nprodw,Nprodw,T);

windProductionMax = 50;
%windProduction = [0:windProductionMax/(Nprodw-1):windProductionMax];
windProduction = [0:windProductionMax/(Nprodw-1):windProductionMax+windProductionMax/(Nprodw-1)];

windProjection= [30 20 40 30];
rRangeWind = 0.25;

%transition_matrix(prodW_t,prodW_tp1,t);
%fra prodW_t til prodW_tp1 p? t
wind_t_TF = zeros(T,Nprodw+1);
wind_t_Prob = zeros(T,Nprodw);

% not equally spaced
for t = 1:T
    wind_t_TF(t,:) = (windProduction<=windProjection(t)+windProjection(t)*rRangeWind & windProduction>windProjection(t)-windProjection(t)*rRangeWind);
    for prodw = 1:Nprodw
        if wind_t_TF(t,prodw+1) == 0
            if wind_t_TF(t,prodw) == 1 % & wind_t_TF(t,prodw+1) == 0
                wind_t_Prob(t,prodw) = (windProjection(t)*(1+rRangeWind)-windProduction(prodw)+(windProductionMax)/(2*(Nprodw-1)))/(windProjection(t)*rRangeWind*2);
            end % else 0
        else % wind_t_TF(t,prodw+1) == 1
            if wind_t_TF(t,prodw) == 0  % & wind_t_TF(t,prodw+1) == 1
                wind_t_Prob(t,prodw) = (windProduction(prodw+1)-windProjection(t)*(1-rRangeWind)-(windProductionMax)/(2*(Nprodw-1)))/(windProjection(t)*rRangeWind*2);
            else % wind_t_TF(t,prodw) == 1 & wind_t_TF(t,prodw+1) == 1
                wind_t_Prob(t,prodw) = (windProduction(prodw+1)*wind_t_TF(t,prodw+1)-windProduction(prodw)*wind_t_TF(t,prodw))/(windProjection(t)*rRangeWind*2);
            end
        end
    end
end
%wind_t_TF
%wind_t_Prob

for t = 1:T-1
    transition_matrix(:,:,t)=wind_t_Prob(t,:).'*wind_t_Prob(t+1,:);
end
transition_matrix
% sum(sum(transition_matrix(:,:,1)))
% sum(sum(transition_matrix(:,:,2)))
% sum(sum(transition_matrix(:,:,3)))

% % equally spaced
% wind_t = zeros(T,Nprodw);
% windProduction = windProduction(1:Nprodw);
% for t = 1:T
%     wind_t(t,:) = (windProduction<windProjection(t)+windProjection(t)*rRangeWind & windProduction>windProjection(t)-windProjection(t)*rRangeWind)/sum((windProduction<windProjection(t)+windProjection(t)*rRangeWind & windProduction>windProjection(t)-windProjection(t)*rRangeWind));
% end
% 
% for t = 1:T-1
%     transition_matrix(:,:,t)=wind_t(t,:).'*wind_t(t+1,:);
% end
% transition_matrix


% windProduction =
% 
%   Columns 1 through 5
% 
%          0    5.5556   11.1111   16.6667   22.2222
% 
%   Columns 6 through 10
% 
%    27.7778   33.3333   38.8889   44.4444   50.0000

% t_tran = 1;
% transition_matrix(:,:,t_tran)= [0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1;
%                                 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1;
%                                 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1;
%                                 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1;
%                                 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1;
%                                 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1;
%                                 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1;
%                                 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1;
%                                 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1;
%                                 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1];
% t_tran = 2;
% transition_matrix(:,:,t_tran)= [0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1;
%                                 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1;
%                                 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1;
%                                 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1;
%                                 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1;
%                                 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1;
%                                 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1;
%                                 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1;
%                                 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1;
%                                 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1];
% t_tran = 3;
% transition_matrix(:,:,t_tran)= [0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1;
%                                 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1;
%                                 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1;
%                                 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1;
%                                 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1;
%                                 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1;
%                                 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1;
%                                 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1;
%                                 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1;
%                                 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1];
% t_tran = 4;
% transition_matrix(:,:,t_tran)= [0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1;
%                                 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1;
%                                 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1;
%                                 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1;
%                                 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1;
%                                 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1;
%                                 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1;
%                                 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1;
%                                 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1;
%                                 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1];

%% Calculating the costs and paths recursively
h = waitbar(0,'Running SDP iteration of ACOPF for 4h...');
counter = 0;
totalIt = T*Nsoc*Nprodw*Nsoc;

ACOPFsolXMap = containers.Map();
ACOPFfvalMap = containers.Map();

tic;
for t = T-1:-1:1
    for soc_t = 1:Nsoc
        for prodW_t = 1:Nprodw
            %transition_matrix(prodW_t,prodW_tp1,t);
            %if sum(transition_matrix(prodW_t,:,t)) ~= 0
                for soc_tp1 = 1:Nsoc
                    socDiffString = num2str(legalSOCs(t+1,soc_tp1)-legalSOCs(t,soc_t));
                    %socDiffString = socDiffString(1:5); % Shorten? for SQG maybe
                    windProdString = num2str(windProduction(prodW_t));
                    keyHandle = [socDiffString windProdString];
                    %tf = isKey(ACOPFsolMap,keyHandle);
                    if isKey(ACOPFsolXMap,keyHandle);
                        ACOPFsolXlast = ACOPFsolXMap(keyHandle);
                        fval = ACOPFfvalMap(keyHandle);
                    else
                    [ACOPFsolXlast, fval, grad] = SimulateACOPF_v02(legalSOCs(t+1,soc_tp1)-legalSOCs(t,soc_t),windProjection,windProduction(prodW_t),rRange,...
                        Pd, Qd,baseMVA, bus, gen,Y,branch, num_var, Econs, ...
                        gencost_inputdata, ...
                        Vmax, Vmin, Pmax, Pmin, Qmax, Qmin,...
                        numbus, ibus, numgen,...
                        TotEnBat0, TotEnBatMax,...
                        ACOPFsolX);
                        ACOPFsolXMap(keyHandle) = ACOPFsolXlast;
                        ACOPFfvalMap(keyHandle) = fval;
                        %counter = counter+1;
                        %waitbar(counter/(10^(sum(wind_t_TF(1,:)))+10^(sum(wind_t_TF(2,:)))+10^(sum(wind_t_TF(3,:)))));
                    end
                    ACOPFsolX=ACOPFsolXlast;
                    transitionCost(soc_tp1,prodW_t) = fval;
                    for prodW_tp1=1:Nprodw
                        %USE IF???? yes, believe so
                        %if transitionCost(soc_tp1,prodW_t) ~= inf
                            %cost_to_go = inf(Nsoc,T,Nprodw);
                            transitionCost(soc_tp1,prodW_t) = ...
                                transitionCost(soc_tp1,prodW_t) + ...
                                cost_to_go(soc_tp1,t+1,prodW_tp1)*...
                                transition_matrix(prodW_t,prodW_tp1,t);
                        %end
                        %cost_to_go(soc_tp1,t,load_tp1) = cost_to_go(soc_t,t,load_tp1)
                        [min_cost, min_soc] = min(transitionCost(:,prodW_t));
                        cost_to_go(soc_t,t,prodW_t) = min_cost;
                        path(soc_t,t,prodW_t) = min_soc;
                    end
                    %counter = counter + 1;
                    %waitbar(counter/totalIt);
                    counter = (3-t) * Nsoc * Nprodw * Nsoc +  (soc_t-1) * Nprodw * Nsoc + (prodW_t-1) * Nsoc + soc_t;
                    waitbar(counter/totalIt); 
                end
            %end
            transitionCost = inf(Nsoc,Nprodw);
        end
    end
end %t
toc
close(h);
xOut=path;
values=cost_to_go;

%% Extracting charing policy and fval given inital SOC

% TryACOPFwSDPv01(RealizedWind,SOC0)
if nargin < 2
  %
    SOC0 = round(Nsoc/2);  % todo : should update this to battery storgae
end
if nargin < 1
    %RealizedWind = [7 4 11 6]; % [30 15 50 25]
    %RealizedWind = [7 5 9 7]; %  windProjection= [30 20 40 30];
    RealizedWind = 0;
end

%%
if RealizedWind == 0
    
    charging = zeros(1,T);
    SOC = [SOC0 0 0 0 0]; % [SOCinitial=25 soc1 soc2 soc3 soc4]
    %fval= values(SOC(1),1,:); % cost_to_go = inf(Nsoc_TM1,T,Nprodw); for any wind!
    fval= 0;
    legalSOCs = [ones(1,Nsoc)*TotEnBat0 ;legalSOCs];
    
    for t =1:T
        [valMinAnyW, WindProdminAnyW] = min(values(SOC(t),t,:));
        SOC(t+1) = path(SOC(t),t,WindProdminAnyW); % path = zeros(Nsoc,T,Nprodw);
        %SOC(t+1) = SOCminAnyW;
        fval = fval + valMinAnyW;
        charging(1,t) = legalSOCs(t+1,SOC(t+1))-legalSOCs(t,SOC(t)); 
        % both legalSOCs and SOC have index 1 value of t=0;
    end
    SOC
    
    % feil, m? g? etter path...
%     for t =1:T
%         [valMinAnyW, SOCminAnyW] = min(values(SOC(t),t,:));
%         %SOC(t+1) = path(SOC(t),t,:); % path = zeros(Nsoc,T,Nprodw);
%         SOC(t+1) = SOCminAnyW;
%         fval = fval + valMinAnyW;
%         charging(1,t) = legalSOCs(t+1,SOC(t+1))-legalSOCs(t,SOC(t)); 
%         % both legalSOCs and SOC have index 1 value of t=0;
%     end

    


else

    charging = zeros(1,T);
    SOC = [SOC0 0 0 0 0]; % [SOCinitial=25 soc1 soc2 soc3 soc4]
    fval= values(SOC(1),1,RealizedWind(1)); % cost_to_go = inf(Nsoc,T,Nprodw);
    for t =1:T
        SOC(t+1) = path(SOC(t),t,RealizedWind(t)); % path = zeros(Nsoc,T,Nprodw);
        fval = fval + values(SOC(t),t,RealizedWind(t));
        charging(1,t) = legalSOCs(t+1,SOC(t+1))-legalSOCs(t,SOC(t));
    end

end

SOC
fval
charging
%%
ACOPFcase=1;

%windProjection= [30 20 40 30];
%windMean= [30 20 50 30];
windMean = windProjection;

parFun={ACOPFcase T windProjection windMean rRange TotEnBatMax};
plotSQGsolutionOfACOPF(parFun,charging);

costT = zeros(Nsoc,Nprodw,T);
pathT = zeros(Nsoc,Nprodw,T);
for t=1:T
    costT(:,:,t)=values(:,t,:);
    pathT(:,:,t)=xOut(:,t,:);
end
costT
pathT


%charging = [legalSOCs(1,SOC(2))-legalSOCs(1,SOC(1)) legalSOCs(1,SOC(3))-legalSOCs(1,SOC(2)) legalSOCs(1,SOC(4))-legalSOCs(1,SOC(3)) legalSOCs(1,1)-legalSOCs(1,SOC(4))] 
end


%Instance(1) = [TotEnBatMax 25];
%Instance(1) = [TotEnBatMax 25];
%Instance(1) = [TotEnBatMax 25];
%% manipulating output

% costT = zeros(Nsoc,Nprodw,T);
% pathT = zeros(Nsoc,Nprodw,T);
% for t=1:T
%     costT(:,:,t)=values(:,t,:);
%     pathT(:,:,t)=xOut(:,t,:);
% end
% costT
% pathT

%min(costT(:,:,1))

% SOC =         5     1     4     1
%             [20     0    15     0]
% fval =  2.3601e+04
% charging =   -5   -20    15   -15
