function [xOut, values, SOC, fval, charging, ACOPFsolXMap, ACOPFfvalMap] = TryACOPFwSDPv04(RealizedWind,ACOPFsolXMap, ACOPFfvalMap,SOC0)
close all
clear
%% Load power system data
% 4 bus case

[Pd, Qd,baseMVA, bus, gen,Y,branch, num_var, Econs, ...
     gencost_inputdata, ...
    Vmax, Vmin, Pmax, Pmin, Qmax, Qmin,...
    numbus, ibus, numgen]=...
        getProblemDataACPOF(1);

%% Initialization 
%Nsoc = 11;
Nsoc = 11;

%% Extracting charing policy and fval given inital SOC

% TryACOPFwSDPv01(RealizedWind,SOC0)
if nargin < 4
  %
    SOC0 = round(Nsoc/2);  % todo : should update this to battery storgae
end
if nargin<3
    ACOPFsolXMap = containers.Map();
    ACOPFfvalMap = containers.Map();
end
if nargin < 1
    %RealizedWind = [7 4 11 6]; % [30 15 50 25]
    %RealizedWind = [7 5 9 7]; %  windProjection= [30 20 40 30];
    RealizedWind = 0;
end
%ACOPFsolXMap
%ACOPFfvalMap

%% Initialization continued
T = 4;
Nprodw = 6;
% charging =
% 
%     -5   -20    10   -10
% 
%  Case ID: 4BusCase_networkdata.xlsx 
% 
% fVals =
% 
%    5.3738e+03


%Nprodw = 11;
% charging =
% 
%     -5   -15    10    -5
% 
%  Case ID: 4BusCase_networkdata.xlsx 
% 
% fVals =
% 
%    6.7479e+03

% Nprodw = 21;
% charging =
% 
%    -2.5000  -15.0000   10.0000   -2.5000
% 
%  Case ID: 4BusCase_networkdata.xlsx 
% 
% fVals =
% 
%    9.5031e+03



cost_to_go = inf(Nsoc,T+1,Nprodw);
transitionCost = inf(Nsoc,Nprodw);
path = ones(Nsoc,T+1,Nprodw);

%for final stages = 0 ???? or . . . . . 
cost_to_go(:,T+1,:) = 0;
transitionCost(Nsoc,:) = 0;
% for soc=1:Nsoc
%     for prodw=1:Nprodw
%         [ACOPFsolXlast, fval, grad] = SimulateACOPF_v02(legalSOCs(t+1,soc_tp1)-legalSOCs(t,soc_t),windProjection,windProduction(prodW_t),rRange,...
%                         Pd, Qd,baseMVA, bus, gen,Y,branch, num_var, Econs, ...
%                         gencost_inputdata, ...
%                         Vmax, Vmin, Pmax, Pmin, Qmax, Qmin,...
%                         numbus, ibus, numgen,...
%                         TotEnBat0, TotEnBatMax,...
%                         ACOPFsolX);
%         cost_to_go(soc,T,prodw)
%         transitionCost(soc,prodw) = fval
%         
% [min_cost, min_soc] = min(transitionCost(:,prodW_t));
%                         cost_to_go(soc_t,t,prodW_t) = min_cost;


TotEnBatMax = 50;
TotEnBat0 = TotEnBatMax/2;

legalSOCs = ones(T+1,1)*[0:(TotEnBatMax/(Nsoc-1)):TotEnBatMax];
legalSOCs(1,:)=TotEnBat0;

%Which ACOPF case?
ACOPFcase = 1; % 4BusCase
%numbus = 4;
% 
% TotEnBatMax = 50; 
%TotEnBat0 = TotEnBatMax/2;
% 
% %How may timesteps?
% T=4; %1,4




% x tries to find how much battery to store
%x0=80+windMean-100;

ACOPFsolX = 0;
rRange = 0;

%% Making impromptu transition matriz
transition_matrix=zeros(Nprodw,Nprodw,T+1);

windProductionMax = 50;
%windProduction = [0:windProductionMax/(Nprodw-1):windProductionMax];
windProduction = [0:windProductionMax/(Nprodw-1):windProductionMax+windProductionMax/(Nprodw-1)];

windProjection= [30 20 40 30];
rRangeWind = 0.25;

%transition_matrix(prodW_t,prodW_tp1,t);
%fra prodW_t til prodW_tp1 p? t
wind_t_TF = zeros(T,Nprodw+1);
wind_t_Prob = zeros(T+2,Nprodw);
wind_t_Prob(T+2,:) = 1;
wind_t_Prob(1,:) = 1;

% not equally spaced
for t = 1:T
    wind_t_TF(t,:) = (windProduction<=windProjection(t)+windProjection(t)*rRangeWind & windProduction>windProjection(t)-windProjection(t)*rRangeWind);
    for prodw = 1:Nprodw
        if wind_t_TF(t,prodw+1) == 0
            if wind_t_TF(t,prodw) == 1 % & wind_t_TF(t,prodw+1) == 0
                wind_t_Prob(t+1,prodw) = (windProjection(t)*(1+rRangeWind)-windProduction(prodw)+(windProductionMax)/(2*(Nprodw-1)))/(windProjection(t)*rRangeWind*2);
            end % else 0
        else % wind_t_TF(t,prodw+1) == 1
            if wind_t_TF(t,prodw) == 0  % & wind_t_TF(t,prodw+1) == 1
                wind_t_Prob(t+1,prodw) = (windProduction(prodw+1)-windProjection(t)*(1-rRangeWind)-(windProductionMax)/(2*(Nprodw-1)))/(windProjection(t)*rRangeWind*2);
            else % wind_t_TF(t,prodw) == 1 & wind_t_TF(t,prodw+1) == 1
                wind_t_Prob(t+1,prodw) = (windProduction(prodw+1)*wind_t_TF(t,prodw+1)-windProduction(prodw)*wind_t_TF(t,prodw))/(windProjection(t)*rRangeWind*2);
            end
        end
    end
end
%wind_t_TF
wind_t_Prob

% for t = 1:T-1
%     transition_matrix(:,:,t)=wind_t_Prob(t,:).'*wind_t_Prob(t+1,:);
% end

for t = 2:T
    transition_matrix(:,:,t)=wind_t_Prob(t-1+1,:).'*wind_t_Prob(t+1,:);
end
transition_matrix(:,:,1)=ones(1,Nprodw).'*wind_t_Prob(2,:);

transition_matrix
% sum(sum(transition_matrix(:,:,1)))
%  sum(sum(transition_matrix(:,:,2)))
%  sum(sum(transition_matrix(:,:,3)))
%  sum(sum(transition_matrix(:,:,4)))
                

%% Calculating the costs and paths recursively
h = waitbar(0,'Running SDP iteration of ACOPF for 4h...');
counter = 0;
totalIt = T*Nsoc*Nprodw*Nsoc;

% ACOPFsolXMap = containers.Map();
% ACOPFfvalMap = containers.Map();

Nprodw_t = ones(1,T+2);
for t = 1 : T
    Nprodw_t(1,t+1) = sum(wind_t_Prob(t+1,:)>0);
end

%%

tic;
for t = T:-1:1
    for soc_tm1 = 1:Nsoc
        for prodW_tm1 = 1:Nprodw_t(1,t)
            %if t~=1
            windProd_tm1=find(wind_t_Prob(t,:)>0,1)+prodW_tm1-1; %index of wind at t
            %transition_matrix(prodW_t,prodW_tp1,t);
            %if sum(transition_matrix(prodW_t,:,t)) ~= 0
            
            %if t ==4?
                for soc_t = 1:Nsoc
%                     socDiffString = num2str(legalSOCs(t+1,soc_t)-legalSOCs(t,soc_tm1));
%                     %socDiffString = socDiffString(1:5); % Shorten? for SQG maybe
%                     windProdString = num2str(windProduction(windProd_tm1));
%                     keyHandle = [socDiffString windProdString];
%                     %tf = isKey(ACOPFsolMap,keyHandle);
%                     if isKey(ACOPFsolXMap,keyHandle);
%                         ACOPFsolXlast = ACOPFsolXMap(keyHandle);
%                         fval = ACOPFfvalMap(keyHandle);
%                     else
%                     [ACOPFsolXlast, fval, grad] = SimulateACOPF_v02(legalSOCs(t+1,soc_t)-legalSOCs(t,soc_tm1),windProjection,windProduction(windProd_tm1),rRange,...
%                         Pd, Qd,baseMVA, bus, gen,Y,branch, num_var, Econs, ...
%                         gencost_inputdata, ...
%                         Vmax, Vmin, Pmax, Pmin, Qmax, Qmin,...
%                         numbus, ibus, numgen,...
%                         TotEnBat0, TotEnBatMax,...
%                         ACOPFsolX);
%                         ACOPFsolXMap(keyHandle) = ACOPFsolXlast;
%                         ACOPFfvalMap(keyHandle) = fval;
%                         %counter = counter+1;
%                         %waitbar(counter/(10^(sum(wind_t_TF(1,:)))+10^(sum(wind_t_TF(2,:)))+10^(sum(wind_t_TF(3,:)))));
%                     end
%                     ACOPFsolX=ACOPFsolXlast;
%                     transitionCost(soc_t,windProd_tm1) = fval;
                    for prodW_t=1:Nprodw_t(1,t+1)
                        windProd_t=find(wind_t_Prob(t+1,:)>0,1)+prodW_t-1; %index of wind at t
                        
                        socDiffString = num2str(legalSOCs(t+1,soc_t)-legalSOCs(t,soc_tm1));
                        %socDiffString = socDiffString(1:5); % Shorten? for SQG maybe
                        windProdString = num2str(windProduction(windProd_t));
                        keyHandle = [socDiffString windProdString];
                        %tf = isKey(ACOPFsolMap,keyHandle);
                        if isKey(ACOPFsolXMap,keyHandle);
                            ACOPFsolXlast = ACOPFsolXMap(keyHandle);
                            fval = ACOPFfvalMap(keyHandle);
                        else
                        [ACOPFsolXlast, fval, grad] = SimulateACOPF_v02(legalSOCs(t+1,soc_t)-legalSOCs(t,soc_tm1),windProjection,windProduction(windProd_t),rRange,...
                            Pd, Qd,baseMVA, bus, gen,Y,branch, num_var, Econs, ...
                            gencost_inputdata, ...
                            Vmax, Vmin, Pmax, Pmin, Qmax, Qmin,...
                            numbus, ibus, numgen,...
                            TotEnBat0, TotEnBatMax,...
                            ACOPFsolX);
                            ACOPFsolXMap(keyHandle) = ACOPFsolXlast;
                            ACOPFfvalMap(keyHandle) = fval;
                            %counter = counter+1;
                            %waitbar(counter/(10^(sum(wind_t_TF(1,:)))+10^(sum(wind_t_TF(2,:)))+10^(sum(wind_t_TF(3,:)))));
                        end
                        ACOPFsolX=ACOPFsolXlast;
                        transitionCost(soc_t,windProd_tm1) = fval;
                        
                        
                        %USE IF???? yes, believe so
                        if transitionCost(soc_t,prodW_t) ~= inf
                            %cost_to_go = inf(Nsoc,T,Nprodw);
                            transitionCost(soc_t,windProd_tm1) = ...
                                transitionCost(soc_t,windProd_tm1) + ...
                                cost_to_go(soc_t,t+1,windProd_t)*...
                                transition_matrix(windProd_tm1,windProd_t,t);
                        end
                        %cost_to_go(soc_tp1,t,load_tp1) = cost_to_go(soc_t,t,load_tp1)
%                         [min_cost, min_soc] = min(transitionCost(:,windProd_tm1));
%                         cost_to_go(soc_tm1,t,windProd_tm1) = min_cost;
%                         path(soc_tm1,t,windProd_tm1) = min_soc;
                    end
                    
                    %counter = counter + 1;
                    %waitbar(counter/totalIt);
                    counter = (3-t) * Nsoc * Nprodw * Nsoc +  (soc_tm1-1) * Nprodw * Nsoc + (prodW_t-1) * Nsoc + soc_tm1;
                    waitbar(counter/totalIt); 
                end
            %else %t==1
                
            %end
            %end
            [min_cost, min_soc] = min(transitionCost(:,windProd_tm1));
            cost_to_go(soc_tm1,t,windProd_tm1) = min_cost;
            path(soc_tm1,t,windProd_tm1) = min_soc;

            transitionCost = inf(Nsoc,Nprodw);
        end
    end
end %t
toc
close(h);
xOut=path;
values=cost_to_go;


%%
if RealizedWind == 0
    
    charging = zeros(1,T);
    SOC = [SOC0 0 0 0 0]; % [SOCinitial=25 soc1 soc2 soc3 soc4]
    %fval= values(SOC(1),1,:); % cost_to_go = inf(Nsoc_TM1,T,Nprodw); for any wind!
    fval= 0;
    %legalSOCs = [ones(1,Nsoc)*TotEnBat0 ;legalSOCs];
    legalSOCs(1,:) = TotEnBat0;
    
    for t =1:T
        [valMinAnyW, WindProdminAnyW] = min(values(SOC(t),t,:));
        SOC(t+1) = path(SOC(t),t,WindProdminAnyW); % path = zeros(Nsoc,T,Nprodw);
        %SOC(t+1) = SOCminAnyW;
        fval = fval + valMinAnyW;
        charging(1,t) = legalSOCs(t+1,SOC(t+1))-legalSOCs(t,SOC(t)); 
        % both legalSOCs and SOC have index 1 value of t=0;
    end
    SOC
    
    % feil, m? g? etter path...
%     for t =1:T
%         [valMinAnyW, SOCminAnyW] = min(values(SOC(t),t,:));
%         %SOC(t+1) = path(SOC(t),t,:); % path = zeros(Nsoc,T,Nprodw);
%         SOC(t+1) = SOCminAnyW;
%         fval = fval + valMinAnyW;
%         charging(1,t) = legalSOCs(t+1,SOC(t+1))-legalSOCs(t,SOC(t)); 
%         % both legalSOCs and SOC have index 1 value of t=0;
%     end

    


else

    charging = zeros(1,T);
    SOC = [SOC0 0 0 0 0]; % [SOCinitial=25 soc1 soc2 soc3 soc4]
    fval= values(SOC(1),1,RealizedWind(1)); % cost_to_go = inf(Nsoc,T,Nprodw);
    for t =1:T
        SOC(t+1) = path(SOC(t),t,RealizedWind(t)); % path = zeros(Nsoc,T,Nprodw);
        fval = fval + values(SOC(t),t,RealizedWind(t));
        charging(1,t) = legalSOCs(t+1,SOC(t+1))-legalSOCs(t,SOC(t));
    end

end

SOC
fval
charging
%%
ACOPFcase=1;

%windProjection= [30 20 40 30];
%windMean= [30 20 50 30];
windMean = windProjection;

parFun={ACOPFcase T windProjection windMean rRange TotEnBatMax};
plotSQGsolutionOfACOPF(parFun,charging);

costT = zeros(Nsoc,Nprodw,T+1);
pathT = zeros(Nsoc,Nprodw,T+1);
for t=1:T+1
    costT(:,:,t)=values(:,t,:);
    pathT(:,:,t)=xOut(:,t,:);
end
costT
pathT


%charging = [legalSOCs(1,SOC(2))-legalSOCs(1,SOC(1)) legalSOCs(1,SOC(3))-legalSOCs(1,SOC(2)) legalSOCs(1,SOC(4))-legalSOCs(1,SOC(3)) legalSOCs(1,1)-legalSOCs(1,SOC(4))] 
end


%Instance(1) = [TotEnBatMax 25];
%Instance(1) = [TotEnBatMax 25];
%Instance(1) = [TotEnBatMax 25];
%% manipulating output

% costT = zeros(Nsoc,Nprodw,T);
% pathT = zeros(Nsoc,Nprodw,T);
% for t=1:T
%     costT(:,:,t)=values(:,t,:);
%     pathT(:,:,t)=xOut(:,t,:);
% end
% costT
% pathT

%min(costT(:,:,1))

% SOC =         5     1     4     1
%             [20     0    15     0]
% fval =  2.3601e+04
% charging =   -5   -20    15   -15
