function [SOC, fval, charging] = TryACOPFwSTv01(RealizedWind,SOC0)
close all
clear 
%% Load power system data
% 4 bus case

[Pd, Qd,baseMVA, bus, gen,Y,branch, num_var, Econs, ...
     gencost_inputdata, ...
    Vmax, Vmin, Pmax, Pmin, Qmax, Qmin,...
    numbus, ibus, numgen]=...
        getProblemDataACPOF(1);

%% Initialization 
T = 4;
Nsoc = 11;

ACOPFcase = 1;

ACOPFsolX = 0;
rRange = 0;

TotEnBatMax = 50;
TotEnBat0 = TotEnBatMax/2;

% TryACOPFwSTv01(RealizedWind,SOC0)
% if nargin < 2
%   %
%     SOC0 = round(Nsoc/2);
% if nargin < 1
%     RealizedWind = [7 6 11 7]; % [30 20 40 30]
% end


%% Making impromptu transition matriz
%transition_matrix=zeros(Nprodw,Nprodw,T);
Nprodw = 11;

windProductionMax = 50;
%windProduction = [0:windProductionMax/(Nprodw-1):windProductionMax];
windProduction = [0:windProductionMax/(Nprodw-1):windProductionMax+windProductionMax/(Nprodw-1)];

windProjection= [30 20 40 30];
rRangeWind = 0.25;

%transition_matrix(prodW_t,prodW_tp1,t);
%fra prodW_t til prodW_tp1 p? t
wind_t_TF = zeros(T,Nprodw+1);
wind_t_Prob = zeros(T,Nprodw);

% not equally spaced
for t = 1:T
    wind_t_TF(t,:) = (windProduction<=windProjection(t)+windProjection(t)*rRangeWind & windProduction>windProjection(t)-windProjection(t)*rRangeWind);
    for prodw = 1:Nprodw
        if wind_t_TF(t,prodw+1) == 0
            if wind_t_TF(t,prodw) == 1 % & wind_t_TF(t,prodw+1) == 0
                wind_t_Prob(t,prodw) = (windProjection(t)*(1+rRangeWind)-windProduction(prodw)+(windProductionMax)/(2*(Nprodw-1)))/(windProjection(t)*rRangeWind*2);
            end % else 0
        else % wind_t_TF(t,prodw+1) == 1
            if wind_t_TF(t,prodw) == 0  % & wind_t_TF(t,prodw+1) == 1
                wind_t_Prob(t,prodw) = (windProduction(prodw+1)-windProjection(t)*(1-rRangeWind)-(windProductionMax)/(2*(Nprodw-1)))/(windProjection(t)*rRangeWind*2);
            else % wind_t_TF(t,prodw) == 1 & wind_t_TF(t,prodw+1) == 1
                wind_t_Prob(t,prodw) = (windProduction(prodw+1)*wind_t_TF(t,prodw+1)-windProduction(prodw)*wind_t_TF(t,prodw))/(windProjection(t)*rRangeWind*2);
            end
        end
    end
end
wind_t_TF
wind_t_Prob

%% Make scenario tree values
%TotEnBatMax = 50;

SOC0 = round(Nsoc/2);
legalSOCs = [0:(TotEnBatMax/(Nsoc-1)):TotEnBatMax];
%legalSOCs = ones(T+1,1)*[0:(TotEnBatMax/(Nsoc-1)):TotEnBatMax];
%legalSOCs(1,:)=legalSOCs(1,SOC0);
 % t = 0 [25 25 25 25 25 25 25 25 25 25 25|
 % t = 1 | 0  5 10 15 20 25 30 35 40 45 50|
 % t = 2 | 0  5 10 15 20 25 30 35 40 45 50|
 % t = 3 | 0  5 10 15 20 25 30 35 40 45 50|
 % t = 4 | 0  5 10 15 20 25 30 35 40 45 50]

ACOPFsolXMap = containers.Map();
ACOPFfvalMap = containers.Map();
 
%values=zeros(T+1,Nsoc,Nsoc,Nprodw);
%values=Inf(T,Nsoc,Nsoc,Nprodw);
%values(1,:,:,:)
%ValuesAddedWithprob=zeros(T+1,Nsoc,Nsoc,Nprodw);
%ValuesAddedWithprob=Inf(T+1,Nsoc,Nsoc,Nprodw);
%ValuesAddedWithprob=ones(T+1,Nsoc,Nsoc,Nprodw)*10000000000000;
%ValuesAddedWithprob(1,:,:,:)=0;

values=Inf(Nsoc,Nsoc,Nprodw);

h = waitbar(0,'Running iterations of ACOPF...');
counter = 0;
totalIt = Nsoc*Nprodw*Nsoc;
tic;


for soc_from=1:Nsoc
    %Nprodw1 = sum(wind_t_Prob(t,:)>0);
    % going though values with wind
    %for prodW_t=find(wind_t_Prob(t,:)>0,1):find(wind_t_Prob(t,:)>0,1)+Nprodw1-1
    for prodw = 1:Nprodw
        for soc_to = 1:Nsoc
            %find(wind_t_TF(1,:),sum(wind_t_TF(1,:))) would give vector of the
            %indices relevant

            socDiffString = num2str(legalSOCs(soc_to)-legalSOCs(soc_from));
            %socDiffString = socDiffString(1:5); % Shorten? for SQG maybe
            windProdString = num2str(windProduction(prodw));
            keyHandle = [socDiffString windProdString];
            %tf = isKey(ACOPFsolMap,keyHandle);
            if isKey(ACOPFsolXMap,keyHandle);
                ACOPFsolXlast = ACOPFsolXMap(keyHandle);
                fval = ACOPFfvalMap(keyHandle);
            else
            [ACOPFsolXlast, fval, grad] = SimulateACOPF_v02(legalSOCs(soc_to)-legalSOCs(soc_from),windProjection,windProduction(prodw),rRange,...
                Pd, Qd,baseMVA, bus, gen,Y,branch, num_var, Econs, ...
                gencost_inputdata, ...
                Vmax, Vmin, Pmax, Pmin, Qmax, Qmin,...
                numbus, ibus, numgen,...
                TotEnBat0, TotEnBatMax,...
                ACOPFsolX);
                ACOPFsolXMap(keyHandle) = ACOPFsolXlast;
                ACOPFfvalMap(keyHandle) = fval;
                %counter = counter+1;
                %waitbar(counter/(10^(sum(wind_t_TF(1,:)))+10^(sum(wind_t_TF(2,:)))+10^(sum(wind_t_TF(3,:)))));
            end
            ACOPFsolX=ACOPFsolXlast;
            values(soc_from,soc_to,prodw) = fval;

            %ValuesAddedWithprob(t+1,soc_from,soc_to,prodW_t) = values(t,soc_from,soc_to,prodW_t)+wind_t_Prob(t,prodW_t)*ValuesAddedWithprob(t,soc_from,soc_to,prodW_t);
%                 if ValuesAddedWithprob(t+1,soc_from,soc_to,prodW_t)==0
%                     ValuesAddedWithprob(t+1,soc_from,soc_to,prodW_t)=Inf;
%                 end
            %counter = (3-t) * Nsoc * Nprodw * Nsoc +  (soc_from-1) * Nprodw * Nsoc + (prodW_t-1) * Nsoc + soc_from;
            counter = counter+1;
            waitbar(counter/totalIt); 
        end %soc_to
    end %prodw
end %soc_from
toc
close(h);
values


% values=Inf(T,Nsoc,Nsoc,Nprodw);
% h = waitbar(0,'Running iterations of ACOPF...');
% counter = 0;
% totalIt = (T-1)*Nsoc*Nprodw*Nsoc/2;
% tic;
% 
% for t=1:T
%     if t ==1
%         NsocL = 1;
%     else
%         NsocL = Nsoc;
%     end
%     for soc_from=1:NsocL
%         if t==1
%             soc_from= SOC0;
%         end
%         Nprodw1 = sum(wind_t_Prob(t,:)>0);
%         % going though values with wind
%         for prodW_t=find(wind_t_Prob(t,:)>0,1):find(wind_t_Prob(t,:)>0,1)+Nprodw1-1
%             for soc_to = 1:Nsoc
%                 %find(wind_t_TF(1,:),sum(wind_t_TF(1,:))) would give vector of the
%                 %indices relevant
% 
%                 socDiffString = num2str(legalSOCs(t+1,soc_to)-legalSOCs(t,soc_from));
%                 %socDiffString = socDiffString(1:5); % Shorten? for SQG maybe
%                 windProdString = num2str(windProduction(prodW_t));
%                 keyHandle = [socDiffString windProdString];
%                 %tf = isKey(ACOPFsolMap,keyHandle);
%                 if isKey(ACOPFsolXMap,keyHandle);
%                     ACOPFsolXlast = ACOPFsolXMap(keyHandle);
%                     fval = ACOPFfvalMap(keyHandle);
%                 else
%                 [ACOPFsolXlast, fval, grad] = SimulateACOPF_v02(legalSOCs(t+1,soc_to)-legalSOCs(t,soc_from),windProjection,windProduction(prodW_t),rRange,...
%                     Pd, Qd,baseMVA, bus, gen,Y,branch, num_var, Econs, ...
%                     gencost_inputdata, ...
%                     Vmax, Vmin, Pmax, Pmin, Qmax, Qmin,...
%                     numbus, ibus, numgen,...
%                     TotEnBat0, TotEnBatMax,...
%                     ACOPFsolX);
%                     ACOPFsolXMap(keyHandle) = ACOPFsolXlast;
%                     ACOPFfvalMap(keyHandle) = fval;
%                     %counter = counter+1;
%                     %waitbar(counter/(10^(sum(wind_t_TF(1,:)))+10^(sum(wind_t_TF(2,:)))+10^(sum(wind_t_TF(3,:)))));
%                 end
%                 ACOPFsolX=ACOPFsolXlast;
%                 values(t,soc_from,soc_to,prodW_t) = fval;
%                 
%                 %ValuesAddedWithprob(t+1,soc_from,soc_to,prodW_t) = values(t,soc_from,soc_to,prodW_t)+wind_t_Prob(t,prodW_t)*ValuesAddedWithprob(t,soc_from,soc_to,prodW_t);
% %                 if ValuesAddedWithprob(t+1,soc_from,soc_to,prodW_t)==0
% %                     ValuesAddedWithprob(t+1,soc_from,soc_to,prodW_t)=Inf;
% %                 end
%                 %counter = (3-t) * Nsoc * Nprodw * Nsoc +  (soc_from-1) * Nprodw * Nsoc + (prodW_t-1) * Nsoc + soc_from;
%                 counter = counter+1;
%                 waitbar(counter/totalIt); 
%             end %soc_tp1
%         end %prodw
%     end %soc_t
% end %t
% toc
% close(h);
% values

%% Calculating columnative values
%Nprodw1 = sum(wind_t_TF(t,:));
%values(t,soc_from,soc_to,prodW_t)
Nprodw1 = sum(wind_t_Prob(1,:)>0);
Nprodw2 = sum(wind_t_Prob(2,:)>0);
Nprodw3 = sum(wind_t_Prob(3,:)>0);
Nprodw4 = sum(wind_t_Prob(4,:)>0);
%ValuesAddedWithProb1 = values(1,SOC0,:,:);
% ValuesAddedWithProb2 = Inf(Nsoc,Nsoc,Nprodw1,Nprodw2);
% ValuesAddedWithProb3 = Inf(Nsoc,Nsoc,Nsoc,Nprodw1,Nprodw2,Nprodw3);
% ValuesAddedWithProb4 = Inf(Nsoc,Nsoc,Nsoc,Nsoc,Nprodw1,Nprodw2,Nprodw3,Nprodw4);
% 
% % OBS NEED PROB!!!
% 
% % for soc_start1 = 1:Nsoc
% %     for soc_end1start2 = 1:Nsoc
% %         %for wprod1 = find(wind_t_Prob(1,:)>0,1):find(wind_t_Prob(1,:)>0,1)+Nprodw1-1
% %         for wprod1 = 1:Nprodw1
% %             %for wprod2 = find(wind_t_Prob(2,:)>0,1):find(wind_t_Prob(2,:)>0,1)+Nprodw2-1
% %             for wprod2 = 1:Nprodw2
% %                 windProd1=find(wind_t_Prob(1,:)>0,1)+wprod1-1;
% %                 windProd2=find(wind_t_Prob(2,:)>0,1)+wprod2-1;
% %                 ValuesAddedWithProb2(soc_start1,soc_end1start2,windProd1,windProd2) = values(SOC0,soc_start1,windProd1) + values(soc_start1,soc_end1start2,windProd2);
% %             end
% %         end
% %     end
% %     counter = counter+1;
% % end
% %ValuesAddedWithProb2
% 
% % for soc_start1 = 1:Nsoc
% %     for soc_end1start2 = 1:Nsoc
% %         for soc_end2start3 = 1:Nsoc
% %             %for wprod1 = find(wind_t_Prob(1,:)>0,1):find(wind_t_Prob(1,:)>0,1)+Nprodw1-1
% %             for wprod1 = 1:Nprodw1
% %                 %for wprod2 = find(wind_t_Prob(2,:)>0,1):find(wind_t_Prob(2,:)>0,1)+Nprodw2-1
% %                 for wprod2 = 1:Nprodw2
% %                     for wprod3 = 1:Nprodw3
% %                         windProd1=find(wind_t_Prob(1,:)>0,1)+wprod1-1;
% %                         windProd2=find(wind_t_Prob(2,:)>0,1)+wprod2-1;
% %                         windProd3=find(wind_t_Prob(3,:)>0,1)+wprod3-1;
% %                         ValuesAddedWithProb3(soc_start1,soc_end1start2,windProd1,windProd2) = values(SOC0,soc_start1,windProd1) + values(soc_start1,soc_end1start2,windProd2)+values(soc_end1start2,soc_end2start3,windProd3);
% %                         %ValuesAddedWithProb2(soc_start1,soc_end1start2,windProd1,windProd2) = values(1,SOC0,soc_start1,windProd1) + values(2,soc_start1,soc_end1start2,windProd2)+values(3,soc_end1start2,soc_end2start3,windProd3);
% %                     end
% %                 end
% %             end
% %         end
% %         counter = counter+1;
% %     end
% % end
% % ValuesAddedWithProb3
% 
% h = waitbar(0,'Running iterations of Scenario Tree...');
% counter = 0;
% totalIt = Nsoc^4*Nprodw1*Nprodw2*Nprodw3*Nprodw4;
% tic;
% % 
% % % this takes forever.... totalIt = 1976535, alt totalIt2 =1331
% for soc_start1 = 1:Nsoc
%     for soc_end1start2 = 1:Nsoc
%         for soc_end2start3 = 1:Nsoc
%             for soc_end3start4 = 1:Nsoc
%                 %for wprod1 = find(wind_t_Prob(1,:)>0,1):find(wind_t_Prob(1,:)>0,1)+Nprodw1-1
%                 for wprod1 = 1:Nprodw1
%                     %for wprod2 = find(wind_t_Prob(2,:)>0,1):find(wind_t_Prob(2,:)>0,1)+Nprodw2-1
%                     for wprod2 = 1:Nprodw2
%                         
%                         windProd1=find(wind_t_Prob(1,:)>0,1)+wprod1-1;
%                         windProd2=find(wind_t_Prob(2,:)>0,1)+wprod2-1;
%                         ValuesAddedWithProb2(soc_start1,soc_end1start2,windProd1,windProd2) = values(SOC0,soc_start1,windProd1) + values(soc_start1,soc_end1start2,windProd2);
%                         %ValuesAddedWithProb2 = Inf(Nsoc,Nsoc,Nprodw1,Nprodw2);
% 
%                         for wprod3 = 1:Nprodw3
%                             
%                             windProd1=find(wind_t_Prob(1,:)>0,1)+wprod1-1;
%                             windProd2=find(wind_t_Prob(2,:)>0,1)+wprod2-1;
%                             windProd3=find(wind_t_Prob(3,:)>0,1)+wprod3-1;
%                             ValuesAddedWithProb3(soc_start1,soc_end1start2,soc_end2start3,windProd1,windProd2,windProd3) = values(SOC0,soc_start1,windProd1) + values(soc_start1,soc_end1start2,windProd2)+values(soc_end1start2,soc_end2start3,windProd3);
%                             %ValuesAddedWithProb3 = Inf(Nsoc,Nsoc,Nsoc,Nprodw1,Nprodw2,Nprodw3);
%                             
%                             for wprod4 = 1:Nprodw4
%                                 windProd1=find(wind_t_Prob(1,:)>0,1)+wprod1-1;
%                                 windProd2=find(wind_t_Prob(2,:)>0,1)+wprod2-1;
%                                 windProd3=find(wind_t_Prob(3,:)>0,1)+wprod3-1;
%                                 windProd4=find(wind_t_Prob(4,:)>0,1)+wprod4-1;
%                                 ValuesAddedWithProb4(soc_start1,soc_end1start2,soc_end2start3,soc_end3start4,windProd1,windProd2,windProd3,windProd4) = values(SOC0,soc_start1,windProd1) + values(soc_start1,soc_end1start2,windProd2)+values(soc_end1start2,soc_end2start3,windProd3)+values(soc_end2start3,soc_end3start4,windProd4);
%                                 %ValuesAddedWithProb4 = Inf(Nsoc,Nsoc,Nsoc,Nsoc,Nprodw1,Nprodw2,Nprodw3,Nprodw4);
%                                 
%                                 counter = counter+1;
%                                 waitbar(counter/totalIt); 
%                             end
%                         end
%                     end
%                 end
%             end
%             counter = counter+1;
%         end
%     end
% end
% toc
% close(h);

% this takes forever.... totalIt = 1976535, alt totalIt2 =1331

% Lets assume some values

% [30 15 50 25]
RealizedWind = [7 4 11 6]; 

w1 = RealizedWind(1)-find(wind_t_Prob(1,:)>0,1)+1;
w2 = RealizedWind(2)-find(wind_t_Prob(2,:)>0,1)+1;
w3 = RealizedWind(3)-find(wind_t_Prob(3,:)>0,1)+1;
w4 = RealizedWind(4)-find(wind_t_Prob(4,:)>0,1)+1;
SOC(1,4) = 1; 

ValuesAddedWithProb1 = Inf(Nsoc);
ValuesAddedWithProb2 = Inf(Nsoc,Nsoc);
ValuesAddedWithProb3 = Inf(Nsoc,Nsoc,Nsoc);
ValuesAddedWithProb4 = Inf(Nsoc,Nsoc,Nsoc);

h = waitbar(0,'Running iterations of Scenario Tree...');
counter = 0;
totalIt2 = Nsoc^3*1*1*1*1;
tic;

% lets go

for soc_start1 = 1:Nsoc
    for soc_end1start2 = 1:Nsoc
        for soc_end2start3 = 1:Nsoc
            %for soc_end3start4 = 1:Nsoc
            soc_end3start4 = SOC(1,4);
                %for wprod1 = find(wind_t_Prob(1,:)>0,1):find(wind_t_Prob(1,:)>0,1)+Nprodw1-1
                %for wprod1 = 1:Nprodw1
                wprod1 = w1;
                    %for wprod2 = find(wind_t_Prob(2,:)>0,1):find(wind_t_Prob(2,:)>0,1)+Nprodw2-1
                    %for wprod2 = 1:Nprodw2
                    
                    windProd1=find(wind_t_Prob(1,:)>0,1)+wprod1-1;
                    ValuesAddedWithProb1(soc_start1) = values(SOC0,soc_start1,windProd1);
                    
                    wprod2 = w2;
                        
                        windProd1=find(wind_t_Prob(1,:)>0,1)+wprod1-1;
                        windProd2=find(wind_t_Prob(2,:)>0,1)+wprod2-1;
                        ValuesAddedWithProb2(soc_start1,soc_end1start2) = values(SOC0,soc_start1,windProd1) + values(soc_start1,soc_end1start2,windProd2);
                        
                        %for wprod3 = 1:Nprodw3
                        wprod3 = w3;
                        
                            windProd1=find(wind_t_Prob(1,:)>0,1)+wprod1-1;
                            windProd2=find(wind_t_Prob(2,:)>0,1)+wprod2-1;
                            windProd3=find(wind_t_Prob(3,:)>0,1)+wprod3-1;
                            ValuesAddedWithProb3(soc_start1,soc_end1start2,soc_end2start3) = values(SOC0,soc_start1,windProd1) + values(soc_start1,soc_end1start2,windProd2)+values(soc_end1start2,soc_end2start3,windProd3);

                            
                            %for wprod4 = 1:Nprodw4
                            wprod4 = w4;
                                windProd1=find(wind_t_Prob(1,:)>0,1)+wprod1-1;
                                windProd2=find(wind_t_Prob(2,:)>0,1)+wprod2-1;
                                windProd3=find(wind_t_Prob(3,:)>0,1)+wprod3-1;
                                windProd4=find(wind_t_Prob(4,:)>0,1)+wprod4-1;
                                ValuesAddedWithProb4(soc_start1,soc_end1start2,soc_end2start3) = values(SOC0,soc_start1,windProd1) + values(soc_start1,soc_end1start2,windProd2)+values(soc_end1start2,soc_end2start3,windProd3)+values(soc_end2start3,soc_end3start4,windProd4);
                                
                                counter = counter+1;
                                waitbar(counter/totalIt2); 
                            %end
                        %end
                    %end
                %end
            %end
        end
    end
end
toc
close(h);
% 
% ValuesAddedWithProb2
% ValuesAddedWithProb3
% ValuesAddedWithProb4

% % Stokastisk: med prob! Expected vals
% 
% for soc_start1 = 1:Nsoc
%     for soc_end1start2 = 1:Nsoc
%         for soc_end2start3 = 1:Nsoc
%             %for soc_end3start4 = 1:Nsoc
%             soc_end3start4 = SOC(1,4);
%                 %for wprod1 = find(wind_t_Prob(1,:)>0,1):find(wind_t_Prob(1,:)>0,1)+Nprodw1-1
%                 %for wprod1 = 1:Nprodw1
%                 wprod1 = w1;
%                     %for wprod2 = find(wind_t_Prob(2,:)>0,1):find(wind_t_Prob(2,:)>0,1)+Nprodw2-1
%                     %for wprod2 = 1:Nprodw2
%                     
%                     windProd1=find(wind_t_Prob(1,:)>0,1)+wprod1-1;
%                     ValuesAddedWithProb1(soc_start1) = values(SOC0,soc_start1,windProd1)*wind_t_Prob(1,windProd1);
% %                     for wprod1_it = find(wind_t_Prob(1,:)>0,1):find(wind_t_Prob(1,:)>0,1)+Nprodw1-1
% %                     ValuesAddedWithProb1(soc_start1) = ValuesAddedWithProb1(soc_start1) + wind_t_Prob(1,wprod1_it)*values(SOC0,soc_start1,wprod1_it);
% %                     end
%                     
%                     wprod2 = w2;
%                         
%                         windProd1=find(wind_t_Prob(1,:)>0,1)+wprod1-1;
%                         windProd2=find(wind_t_Prob(2,:)>0,1)+wprod2-1;
%                         ValuesAddedWithProb2(soc_start1,soc_end1start2) = values(SOC0,soc_start1,windProd1)*wind_t_Prob(1,windProd1) + values(soc_start1,soc_end1start2,windProd2)*wind_t_Prob(2,windProd2);
% %                         ValuesAddedWithProb2(soc_start1,soc_end1start2) = values(SOC0,soc_start1,windProd1);
% %                         for wprod2_it = find(wind_t_Prob(2,:)>0,1):find(wind_t_Prob(2,:)>0,1)+Nprodw2-1
% %                         ValuesAddedWithProb2(soc_start1,soc_end1start2) = ValuesAddedWithProb2(soc_start1,soc_end1start2) + wind_t_Prob(2,wprod2_it)*values(soc_start1,soc_end1start2,wprod2_it);
% %                         end
%                         
%                         %for wprod3 = 1:Nprodw3
%                         wprod3 = w3;
%                         
%                             windProd1=find(wind_t_Prob(1,:)>0,1)+wprod1-1;
%                             windProd2=find(wind_t_Prob(2,:)>0,1)+wprod2-1;
%                             windProd3=find(wind_t_Prob(3,:)>0,1)+wprod3-1;
%                             ValuesAddedWithProb3(soc_start1,soc_end1start2,soc_end2start3) = values(SOC0,soc_start1,windProd1)*wind_t_Prob(1,windProd1) + values(soc_start1,soc_end1start2,windProd2)*wind_t_Prob(2,windProd2) + values(soc_end1start2,soc_end2start3,windProd3)*wind_t_Prob(3,windProd3);
%                             
%                             
%                             %for wprod4 = 1:Nprodw4
%                             wprod4 = w4;
%                                 windProd1=find(wind_t_Prob(1,:)>0,1)+wprod1-1;
%                                 windProd2=find(wind_t_Prob(2,:)>0,1)+wprod2-1;
%                                 windProd3=find(wind_t_Prob(3,:)>0,1)+wprod3-1;
%                                 windProd4=find(wind_t_Prob(4,:)>0,1)+wprod4-1;
%                                 ValuesAddedWithProb4(soc_start1,soc_end1start2,soc_end2start3) = values(SOC0,soc_start1,windProd1)*wind_t_Prob(1,windProd1) + values(soc_start1,soc_end1start2,windProd2)*wind_t_Prob(2,windProd2) + values(soc_end1start2,soc_end2start3,windProd3)*wind_t_Prob(3,windProd3) + values(soc_end2start3,soc_end3start4,windProd4)*wind_t_Prob(4,windProd4);
%                                 
%                                 counter = counter+1;
%                                 waitbar(counter/totalIt2); 
%                             %end
%                         %end
%                     %end
%                 %end
%             %end
%         end
%     end
% end
% toc
% close(h);

ValuesAddedWithProb2
ValuesAddedWithProb3
ValuesAddedWithProb4



% for t=1:T
%     if t ==1
%         NsocL = 1;
%     else
%         NsocL = Nsoc;
%     end
%     for soc_from=1:NsocL
%         if t==1
%             soc_from= SOC0;
%         end
%         Nprodw1 = sum(wind_t_TF(t,:));
%         % going though values with wind
%         for prodW_t=find(wind_t_TF(1,:),1):find(wind_t_TF(1,:),1)+Nprodw1
%             for soc_to = 1:Nsoc
%                 %find(wind_t_TF(1,:),sum(wind_t_TF(1,:))) would give vector of the
%                 %indices relevant
%                 if ValuesAddedWithprob(t+1,soc_from,soc_to,prodW_t)<1
%                     ValuesAddedWithprob(t+1,soc_from,soc_to,prodW_t)=Inf;
%                 else
%                     ValuesAddedWithprob(t+1,soc_from,soc_to,prodW_t)
%                 end
%             end %soc_tp1
%         end %prodw
%     end %soc_t
% end %t
% ValuesAddedWithprob

%% Calculating optimal path
%ValuesAddedWithprob=inf(T,Nsoc,Nsoc,Nprodw);
SOC =   zeros(1,T);    %SOC
fval=   inf(1,T);      %added val
%OptPath_SOCandValuesAddedWithprob(1,4) gives best Soc at time 4
%OptPath_SOCandValuesAddedWithprob(2,3) gives best value at time 3


%starts at SOC0 and 0
%OptPath_SOCandvalue(1,1)=SOC0;
%OptPath_SOCandvalue(2,1)= 0;

% [30 15 50 25]
RealizedWind = [7 4 11 6]; 

w1 = RealizedWind(1)-find(wind_t_Prob(1,:)>0,1)+1;
w2 = RealizedWind(2)-find(wind_t_Prob(2,:)>0,1)+1;
w3 = RealizedWind(3)-find(wind_t_Prob(3,:)>0,1)+1;
w4 = RealizedWind(4)-find(wind_t_Prob(4,:)>0,1)+1;

%ValuesAddedWithprob(t,soc_from,soc_to,prodW_t) 
%[opt_val_t, best_soc] = min(ValuesAddedWithprob(T,:,1,RealizedWind(4)));
            SOC(1,T) = 1;        
            %fval(1,T) = ValuesAddedWithprob(T,SOC(1,T),,RealizedWind(4));
            
    % Going backwards
    
% ValuesAddedWithProb1 = values(1,SOC0,:,:);
% ValuesAddedWithProb2 = Inf(Nsoc,Nsoc,Nprodw1,Nprodw2);
% ValuesAddedWithProb3 = Inf(Nsoc1,Nsoc2,Nsoc3,Nprodw1,Nprodw2,Nprodw3);
% ValuesAddedWithProb4 = Inf(Nsoc1,Nsoc2,Nsoc3,Nsoc4,Nprodw1,Nprodw2,Nprodw3,Nprodw4);
    
    SOC(1,4) = 1; 
    
    %ValuesAddedWithProb4(:,:,:,SOC(1,T),w1,w2,w3,w4)
    [minVal, minSOC] = min(min(min(ValuesAddedWithProb4(:,:,:))));
    fval(1,4) = minVal;
    SOC(1,3) = minSOC;
    
    [minVal, minSOC] = min(min(ValuesAddedWithProb3(:,:,SOC(1,3))));
    fval(1,3) = minVal;
    SOC(1,2) = minSOC;
    
    [minVal, minSOC] = min(ValuesAddedWithProb2(:,SOC(1,2)));
    fval(1,2) = minVal;
    SOC(1,1) = minSOC;
    
    %fval(1,1) = ValuesAddedWithProb1(SOC(1,1),w1);
    fval(1,1) = values(SOC0,SOC(1,1),w1);
    
    

%for t=T:-1:2
    %Nprodw1 = sum(wind_t_TF(1,:));
    % going though values with wind
    %for prodW_t=find(wind_t_TF(1,:),1):find(wind_t_TF(1,:),1)+Nprodw1-1

        %ValuesAddedWithprob(t,soc_from,soc_to,prodW_t) 

%         [opt_val_t, best_soc_from_t] = min(ValuesAddedWithprob(t+1,:,SOC(1,t),RealizedWind(t)));
%             SOC(1,t-1) = best_soc_from_t;        
%             fval(1,t) = opt_val_t;
%    % end
% %end
%             fval(1,1) = ValuesAddedWithprob(1,SOC0,SOC(1,1),RealizedWind(1));

%SOC = OptPath_SOCandvalue(1,T)
%fval = OptPath_SOCandvalue(2,T)

charging = zeros(1,T);
charging(1,1) = legalSOCs(SOC(1))-legalSOCs(SOC0);
for t =2:T
    charging(1,t) = legalSOCs(SOC(t))-legalSOCs(SOC(t-1));
end


windMean= [30 20 50 30];

parFun={ACOPFcase T windProjection windMean rRange TotEnBatMax};
plotSQGsolutionOfACOPF(parFun,charging);

SOC
fval
charging

% from SDP 
% SOC =         5     1     4     1
% fval =  2.3601e+04
% charging =   -5   -20    15   -15


% from ST med prob
% SOC =         5     1     3     1
% fval =  4.9406e+03
% charging =   -5   -20    10   -10

% from ST uten prob
% SOC =         5     1     3     1
% fval =  2.0302+04
% charging =   -5   -20    10   -10

end

