% Simple implementation of ACOPF with SQG version 5 
% v02_1 is reformulated to use SOC in stead of charing values, and also 
% uses a step scale small enought to be on par with the gradient values
% Simple 4 bus case as illustration and starting point
%  See fiugre for picture and parameters
%
%  Pol 1 uses only upper and lower bounds on Xs
%  ----------------------------------------------------

close all
clear all
%%%%%%%%%%%%%clc

%Which ACOPF case?
ACOPFcase = 1; % 4BusCase
numbus = 4;

TotEnBatMax = 50;
TotEnBat0 = TotEnBatMax/2;

%How may timesteps?
T=4; %1,4 % only done for T =4

% Solves the test problem min E[Cgen(Pgen)] with SQG where wind power  Pw 
% is distributed uniformly around windMean on the range [(1-wRange)z (1+wRange)z] 
% where z is an arbitrary element of wind.

% Simple case where four time steps% Simple case where only one step

% 1. Setting the test problem

if T ==1
   % HERE X's are the actual charging: TODO make to SOC

    windMean=30;
    rRange = 0.25;

    %used to calc g and w_reaised
    windProjection = 25; %not used I believe

    %x=[Pg];
    % x tries to find how much battery to store
    x0=80+windMean-100;   
        %!! meaning of 80 and 100? Should be parameters?
    %x0=100-80-windMean;
    parConstr = {[(x0-windMean)] [(x0+windMean)]};






    % 1.2 Setting SQG parameters
    %parFun(Nagents,T,SOC,priceMean,rRange)
    parFun={ACOPFcase T windProjection windMean rRange TotEnBatMax};

    parAlg={
      { 'ProblemNames' 'Bus 4 Period 1' }
        { 'ProblemDimensions' 1 }
        { 'ProblemTypes' 'min' }  
        { 'StepMultiplier' 0.5}  
        { 'NumberIterations' 5000 }
        { 'InitialStep' 0.02 }  
        { 'PlotFunctionAverage' 'yes'}
        { 'PlotFunctionObservations' 'yes'}
        { 'IndexesPlottedVariables' 1}
       { 'SaveTraceFile' 'ACOPF4bus1Period_01'}
        { 'StepFiniteDifferences' 0.05}
        %{ 'FunctionReferenceValue' fSol }
        %{ 'ReferencesPlottedVariables' xSol(1)}
        { 'AveragingFiniteDifferences' 0.1}
        { 'ExperimentDescription' 'Produced by Stochastic ACOPF'}
        };


    % 1.3 Calling SQG
    rng('default');   % to start from default seed
    tic

    [xOut,fval,exitFlag,InfIter]=SQG_v05_1(@SimulateACOPF_Opt_v02_1B,parFun,parAlg,x0,@ACOPFsimBounds,parConstr);

    tOpt=toc

    xOut
end

% 1. Setting the test problem

if T ==4
    % HERE X's are the SOC level to go to , and the thresholds
    
    % plicy [x01 x02 x03 x11 x12]
    x0 = [40 25 10 17.5 37.5];

    windMean= [30 20 50 30];
    rRange = 0.25;

    %used to calc g and w_reaised
    windProjection = [35 35 35 35]; %??

  
    SOCmax = TotEnBatMax;
    SOCmin = 0;
    parConstr = {[SOCmin] [SOCmax]};


   % NumberOfIterations = 200;


    % 1.2 Setting SQG parameters
    %parFun(Nagents,T,SOC,priceMean,rRange)
    
    % NumIt to make progressbar, not used here
    parFun={ACOPFcase T windProjection windMean rRange TotEnBatMax };
    %^if forward differences
   
    % [Alexei]! Why is the name the same as in parAlg?
    % [Sondre]  Because I want to use it do display the progress-bar bar
    %           and dont know how I would extract the information otherwise
   
    %parFun={ACOPFcase T windProjection windMean rRange TotEnBatMax};
    
    % Use these settings for forward differences
    parAlg={
      { 'ProblemNames' 'Bus 4 Period 4' }
        { 'ProblemDimensions' 5 }
        { 'ProblemTypes' 'min' }  
        { 'StepMultiplier' 0.5}  
        { 'NumberIterations' 200 }
        { 'InitialStep' 0.02 }  
        { 'PlotFunctionAverage' 'yes'}
        { 'PlotFunctionObservations' 'yes'}
        %{ 'IndexesPlottedVariables' 1}
        { 'IndexesPlottedVariables' 1 2 3 4 5}
        { 'SaveTraceFile' 'ACOPF4bus4Period_pol01'}
        { 'SaveFigures' 'v02_pol1_FA' 'v02_pol1_FO' 'v02_pol1_V1' 'v02_pol1_V2' 'v02_pol1_V3' 'v02_pol1_V4' 'v02_pol1_V5'}
        %{ 'StepFiniteDifferences' 0.05} %What Alexei used
        %{ 'StepFiniteDifferences' 0.01} %Sondre tries smaller
        { 'StepFiniteDifferences' 0.005} %Sondre tries smaller
        %{ 'FunctionReferenceValue' fSol }
        %{ 'ReferencesPlottedVariables' xSol(1)}
        %{ 'ReferencesPlottedVariables' xSol(1) xSol(2) xSol(3) xSol(4)}
        { 'AveragingFiniteDifferences' 0.1}
        { 'ExperimentDescription' 'Produced by Stochastic ACOPF'}
        };
    
    
  
    % 1.3 Calling SQG
    
    rng('default');
    tic

  

%%%%%% OBS %%%%%%    
%     %[xOut,fval,exitFlag,InfIter]=SQG_v05_1(@SimulateACOPF_Opt_v02_1B,parFun,parAlg,x0,@ACOPFsimBounds,parConstr);
%     %[Sondre 01.08] - I get error when using v05_1 for seeveral time steps
%    
%     Error using  + 
%           Matrix dimensions must agree.
% 
%     Error in SQG_v05_1 (line 468)
%           pathLength(i+1,:,:)=pathLength(i,:,:)+step';
%%%%%%%%%%%%%%%%%    

    [xOut,fval,exitFlag,InfIter]=SQG_v05(@SimulateACOPF_Opt_v02_pol1,parFun,parAlg,x0,@ACOPFsimBounds,parConstr);
    
    tOpt=toc
 
    xOut


% 
% 
%     SOC0 = TotEnBatMax/2;
% 
%     charging = zeros(1,T);
%     SOC = [SOC0 xOut]; % [SOCinitial=25 soc1 soc2 soc3 soc4]
%     %fval= values(SOC(1),1,RealizedWind(1)); % cost_to_go = inf(Nsoc,T,Nprodw);
%     for t =1:T
%     %    SOC(t+1) = path(SOC(t),t,RealizedWind(t)); % path = zeros(Nsoc,T,Nprodw);
%     %    fval = fval + values(SOC(t),t,RealizedWind(t));
%         charging(1,t) = SOC(t+1)-SOC(t);
%     end
%     charging
% 
%     plotSQGsolutionOfACOPF(parFun,charging);
% 
% 
end


%  xOut is result
    %update control variable values
% 1 theta1
% 2 theta2
% 3 theta3
% 4 theta4
% 5 V_1
% 6 V_2
% 7 V_3
% 8 V_4
% 9 P_1
% 10 P_2
% 11 P_3
% 12 P_4
% 13 Q_1
% 14 Q_2
% 15 Q_3
% 16 Q_4

