function [Pd, Qd, Pg, Qg,baseMVA, bus, gen,Y,branch, num_var, Econs, ...
     gencost_inputdata, ...
    Vmax, Vmin, Pmax, Pmin, Qmax, Qmin,...
    numbus, ibus, numgen]=...
        getProblemDataACPOF2(parFun1)
        %% Loading data
        
if(parFun1 ==1)
    

S='4BusCase_networkdata.xlsx';
file ='4BusCase_networkdata.xlsx';
pathname = '/Users/sondrefharbo/OneDrive - NTNU/Prosjektoppgaver og Mastere/3 Master Optimering/OptACOPFKodeSommer/';

fprintf(' Case ID: %s \n',file);


[Parameter_data, Parameter_Character_Data] = xlsread(S, 'Parameters');
[bus, Character_Data] = xlsread(S, 'BusData');

[gen, Character_Data] = xlsread(S, 'GenData');
% Gets data for each gen bus of:  busnr	Pg	Qg	Qmax	Qmin	Vg	MVABase	status	Pmax	Pmin

[branch, Character_Data] = xlsread(S, 'BranchData');
[area, Character_Data] = xlsread(S, 'AreaData');
[areanamedata, areaname] = xlsread(S, 'AreaName');
[gencost_inputdata, Character_Data] = xlsread(S, 'GenCostData');
[Pd, Character_Data] = xlsread(S, 'Pd');
[Qd, Character_Data] = xlsread(S, 'Qd');
[Econs, Character_Data] = xlsread(S, 'Econs');
% [EconsColumn, Character_Data] = xlsread(S, 'EconsColumn');
% 

baseMVA                    = 100; %MVA
baseKV                     = 110; %KV
casemult                   = 1;
%varlimit                   = cell2mat(Parameter_Character_Data(5,2));
powerflow_tolerance        = 1.0000e-03;

% if SOC approach
%SOC = SOC * casemult/baseMVA;


% numbus = 4;
% numline = 6;
% numgen = 3;
% numarea = 1;
% N=4; %timesteps per simulation

Line_flow_limits2=1;
[numbus,N] = size(bus);
[numline,N] = size(branch);
[numgen,N] = size(gen);
[numarea,N] = size(area);


num_var = numbus*4;

% numbus
% numline
% numgen
% numarea

Bustype = zeros(1,numbus);
Bustype_start = zeros(1,numbus);

for ibus = 1:numbus
   Bustype(ibus)= ' ';
end

Pload = zeros(1,numbus);
Qload = zeros(1,numbus);
Vmax = zeros(1,numbus);
Vmin = zeros(1,numbus);

frombus = zeros(1,numline);
tobus = zeros(1,numline);
R = zeros(1,numline);
X = zeros(1,numline);
Bcap = zeros(1,numline);
flowmax = zeros(1,numline);
BranchStatus = zeros(1,numline);
Vsched = zeros(1,numgen);
Pgen = zeros(1,numgen);
Qgen = zeros(1,numgen);
Pmax = zeros(1,numgen);
Pmin = zeros(1,numgen);
Qmax = zeros(1,numgen);
Qmin = zeros(1,numgen);
genbus = zeros(1,numgen);
busgen = zeros(1,numbus);
original_genbus = zeros(1,numgen);

for ibus = 1:numbus
      bustype_number = bus(ibus,2);
   if bustype_number == 1 
     Bustype(ibus) = 'L';
  end  
  if bustype_number == 2 
     Bustype(ibus) = 'G';
  end  
  if bustype_number == 3 
     Bustype(ibus) = 'S';
     refbus = ibus;
  end  
   Bustype_start(ibus) = Bustype(ibus);
   Pload(ibus) = bus(ibus,3)* casemult/baseMVA;
   Qload(ibus) = bus(ibus,4)* casemult/baseMVA;
   Vmax(ibus) = bus(ibus,12);
   Vmin(ibus) = bus(ibus,13);
end

% Pload
% Qload
% Vmax
% Vmin
for igen = 1:numgen
   ibus = gen(igen,1);
   genbus(igen) = ibus;
   busgen(ibus) = igen;
   original_genbus(igen) = ibus;
   Pgen(igen) = gen(igen,2)* casemult/baseMVA;
   Qgen(igen) = gen(igen,3)* casemult/baseMVA;
   Pmax(igen) = gen(igen,9)/baseMVA;
   Pmin(igen) = gen(igen,10)/baseMVA;
   Qmax(igen) = gen(igen,4)/baseMVA;
   Qmin(igen) = gen(igen,5)/baseMVA;
   %if varlimit == 'N'
   %   Qmax(igen) = 99.;
    %  Qmin(igen) = -99.;
   %end
   Vsched(igen) = gen(igen,6);
end


%%
% This matrix should be updated later,
% I do first simualtion to just check how my integration would be


%1
% Pload=Pd(:,1)'* casemult/baseMVA;
% Qload=Qd(:,1)'* casemult/baseMVA;

% %2
% Pload2=Pd(:,2)'* casemult/baseMVA;
% Qload2=Qd(:,2)'* casemult/baseMVA;
% 
% %3
% Pload3=Pd(:,3)'* casemult/baseMVA;
% Qload3=Qd(:,3)'* casemult/baseMVA;
% 
% %4
% Pload4=Pd(:,4)'* casemult/baseMVA;
% Qload4=Qd(:,4)'* casemult/baseMVA;

% %5
% Pload5=Pd(:,5)'* casemult/baseMVA;
% Qload5=Qd(:,5)'* casemult/baseMVA;
% 
% %6
% Pload6=Pd(:,6)'* casemult/baseMVA;
% Qload6=Qd(:,6)'* casemult/baseMVA;
% 
% %7
% Pload7=Pd(:,7)'* casemult/baseMVA;
% Qload7=Qd(:,7)'* casemult/baseMVA;
% 
% %8
% Pload8=Pd(:,8)'* casemult/baseMVA;
% Qload8=Qd(:,8)'* casemult/baseMVA;
% 
% %9
% Pload9=Pd(:,9)'* casemult/baseMVA;
% Qload9=Qd(:,9)'* casemult/baseMVA;
% 
% %10
% Pload10=Pd(:,10)'* casemult/baseMVA;
% Qload10=Qd(:,10)'* casemult/baseMVA;
% 
% %11
% Pload11=Pd(:,11)'* casemult/baseMVA;
% Qload11=Qd(:,11)'* casemult/baseMVA;
% 
% %12
% Pload12=Pd(:,12)'* casemult/baseMVA;
% Qload12=Qd(:,12)'* casemult/baseMVA;
% 
% %13
% Pload13=Pd(:,13)'* casemult/baseMVA;
% Qload13=Qd(:,13)'* casemult/baseMVA;
% 
% %14
% Pload14=Pd(:,14)'* casemult/baseMVA;
% Qload14=Qd(:,14)'* casemult/baseMVA;
% 
% %15
% Pload15=Pd(:,15)'* casemult/baseMVA;
% Qload15=Qd(:,15)'* casemult/baseMVA;
% 
% %16
% Pload16=Pd(:,16)'* casemult/baseMVA;
% Qload16=Qd(:,16)'* casemult/baseMVA;

% %17
% Pload17=Pd(:,17)'* casemult/baseMVA;
% Qload17=Qd(:,17)'* casemult/baseMVA;
% 
% %18
% Pload18=Pd(:,18)'* casemult/baseMVA;
% Qload18=Qd(:,18)'* casemult/baseMVA;
% 
% %19
% Pload19=Pd(:,19)'* casemult/baseMVA;
% Qload19=Qd(:,19)'* casemult/baseMVA;
% 
% %20
% Pload20=Pd(:,20)'* casemult/baseMVA;
% Qload20=Qd(:,20)'* casemult/baseMVA;
% 
% %21
% Pload21=Pd(:,21)'* casemult/baseMVA;
% Qload21=Qd(:,21)'* casemult/baseMVA;
% 
% %22
% Pload22=Pd(:,22)'* casemult/baseMVA;
% Qload22=Qd(:,22)'* casemult/baseMVA;
% 
% %23
% Pload23=Pd(:,23)'* casemult/baseMVA;
% Qload23=Qd(:,23)'* casemult/baseMVA;
% 
% %24
% Pload24=Pd(:,24)'* casemult/baseMVA;
% Qload24=Qd(:,24)'* casemult/baseMVA;
% 

 %% lines

for iline = 1:numline
   frombus(iline) = branch(iline,1);
   tobus(iline)   = branch(iline,2);
   R(iline)       = branch(iline,3);
   X(iline)       = branch(iline,4);
   Bcap(iline)    = branch(iline,5);
   flowmax(iline) = branch(iline,6);
   BranchStatus(iline) = branch(iline,11);
end
Y = zeros(numbus,numbus);
for iline = 1:numline
    if BranchStatus(iline) == 1
        Y(frombus(iline),tobus(iline)) = Y(frombus(iline),tobus(iline))-1/(R(iline)+sqrt(-1)*X(iline));
        Y(tobus(iline),frombus(iline)) = Y(tobus(iline),frombus(iline))-1/(R(iline)+sqrt(-1)*X(iline));
    end
end
for ibus = 1:numbus
    Y(ibus,ibus) = -sum(Y(ibus,:));
end
for iline = 1:numline
    if BranchStatus(iline) == 1
        Y(frombus(iline),frombus(iline)) = Y(frombus(iline),frombus(iline))+sqrt(-1)*Bcap(iline)/2;
        Y(tobus(iline),tobus(iline)) = Y(tobus(iline),tobus(iline))+sqrt(-1)*Bcap(iline)/2;
    end
end

G=real(Y);
B=imag(Y);

%Init voltage and angle Variables
%v = ones(1,numbus);
%angle = zeros(1,numbus);
v = bus(:,8);
angle = bus(:,9)*(pi/180);
for igen = 1:numgen
    ibus = genbus(igen);
    v(ibus) = Vsched(igen);
end

nbus = numbus;                % Number of buss
ncircuits = numline;               % Number of Interfaces between buss


for iline = 1:numline
   fbus(iline) = frombus(iline);
   tbus(iline) = tobus(iline);
   xckt(iline) = X(iline);
   flowmax_perckt(iline) = flowmax(iline);
   monitor_circuit(iline) = BranchStatus(iline);
end

% end of temp2
%%
elseif(parFun1 ==2)
    %% Loading data

S='9BusCase_networkdata.xlsx';
file ='9BusCase_networkdata.xlsx';
pathname = '/Users/sondrefharbo/OneDrive - NTNU/Prosjektoppgaver og Mastere/3 Master Optimering/OptACOPFKodeSommer/';

fprintf(' Case ID: %s \n',file);


[Parameter_data, Parameter_Character_Data] = xlsread(S, 'Parameters');
[bus, Character_Data] = xlsread(S, 'BusData');

[gen, Character_Data] = xlsread(S, 'GenData');
% Gets data for each gen bus of:  busnr	Pg	Qg	Qmax	Qmin	Vg	MVABase	status	Pmax	Pmin

[branch, Character_Data] = xlsread(S, 'BranchData');
[area, Character_Data] = xlsread(S, 'AreaData');
[areanamedata, areaname] = xlsread(S, 'AreaName');
[gencost_inputdata, Character_Data] = xlsread(S, 'GenCostData');
[Pd, Character_Data] = xlsread(S, 'Pd');
[Qd, Character_Data] = xlsread(S, 'Qd');
[Pg, Character_Data] = xlsread(S, 'Pg');
[Qg, Character_Data] = xlsread(S, 'Qg');
[Econs, Character_Data] = xlsread(S, 'Econs');
% [EconsColumn, Character_Data] = xlsread(S, 'EconsColumn');
% 

baseMVA                    = 100; %MVA
baseKV                     = 110; %KV
casemult                   = 1;
%varlimit                   = cell2mat(Parameter_Character_Data(5,2));
powerflow_tolerance        = 1.0000e-03;

% if SOC approach
%SOC = SOC * casemult/baseMVA;




Line_flow_limits2=1;
[numbus,N] = size(bus);
[numline,N] = size(branch);
[numgen,N] = size(gen);
numarea = length(area);

% numbus = 9;
% numline = 9;
% numgen = 3;
% numarea = 3;
 N=24; %timesteps per simulation


num_var = numbus*4;

% numbus
% numline
% numgen
% numarea

Bustype = zeros(1,numbus);
Bustype_start = zeros(1,numbus);

for ibus = 1:numbus
   Bustype(ibus)= ' ';
end

Pload = zeros(1,numbus);
Qload = zeros(1,numbus);
Vmax = zeros(1,numbus);
Vmin = zeros(1,numbus);

frombus = zeros(1,numline);
tobus = zeros(1,numline);
R = zeros(1,numline);
X = zeros(1,numline);
Bcap = zeros(1,numline);
flowmax = zeros(1,numline);
BranchStatus = zeros(1,numline);
Vsched = zeros(1,numgen);
Pgen = zeros(1,numgen);
Qgen = zeros(1,numgen);
Pmax = zeros(1,numgen);
Pmin = zeros(1,numgen);
Qmax = zeros(1,numgen);
Qmin = zeros(1,numgen);
genbus = zeros(1,numgen);
busgen = zeros(1,numbus);
original_genbus = zeros(1,numgen);

for ibus = 1:numbus
      bustype_number = bus(ibus,2);
   if bustype_number == 1 
     Bustype(ibus) = 'L';
  end  
  if bustype_number == 2 
     Bustype(ibus) = 'G';
  end  
  if bustype_number == 3 
     Bustype(ibus) = 'S';
     refbus = ibus;
  end  
   Bustype_start(ibus) = Bustype(ibus);
   Pload(ibus) = bus(ibus,3)* casemult/baseMVA;
   Qload(ibus) = bus(ibus,4)* casemult/baseMVA;
   Vmax(ibus) = bus(ibus,12);
   Vmin(ibus) = bus(ibus,13);
end

% Pload
% Qload
% Vmax
% Vmin
for igen = 1:numgen
   ibus = gen(igen,1);
   genbus(igen) = ibus;
   busgen(ibus) = igen;
   original_genbus(igen) = ibus;
   Pgen(igen) = gen(igen,2)* casemult/baseMVA;
   Qgen(igen) = gen(igen,3)* casemult/baseMVA;
   Pmax(igen) = gen(igen,9)/baseMVA;
   Pmin(igen) = gen(igen,10)/baseMVA;
   Qmax(igen) = gen(igen,4)/baseMVA;
   Qmin(igen) = gen(igen,5)/baseMVA;
   %if varlimit == 'N'
   %   Qmax(igen) = 99.;
    %  Qmin(igen) = -99.;
   %end
   Vsched(igen) = gen(igen,6);
end


%%
% This matrix should be updated later,
% I do first simualtion to just check how my integration would be


% %1
% Pload=Pd(:,1)'* casemult/baseMVA;
% Qload=Qd(:,1)'* casemult/baseMVA;

% %2
% Pload2=Pd(:,2)'* casemult/baseMVA;
% Qload2=Qd(:,2)'* casemult/baseMVA;
% 
% %3
% Pload3=Pd(:,3)'* casemult/baseMVA;
% Qload3=Qd(:,3)'* casemult/baseMVA;
% 
% %4
% Pload4=Pd(:,4)'* casemult/baseMVA;
% Qload4=Qd(:,4)'* casemult/baseMVA;

% %5
% Pload5=Pd(:,5)'* casemult/baseMVA;
% Qload5=Qd(:,5)'* casemult/baseMVA;
% 
% %6
% Pload6=Pd(:,6)'* casemult/baseMVA;
% Qload6=Qd(:,6)'* casemult/baseMVA;
% 
% %7
% Pload7=Pd(:,7)'* casemult/baseMVA;
% Qload7=Qd(:,7)'* casemult/baseMVA;
% 
% %8
% Pload8=Pd(:,8)'* casemult/baseMVA;
% Qload8=Qd(:,8)'* casemult/baseMVA;
% 
% %9
% Pload9=Pd(:,9)'* casemult/baseMVA;
% Qload9=Qd(:,9)'* casemult/baseMVA;
% 
% %10
% Pload10=Pd(:,10)'* casemult/baseMVA;
% Qload10=Qd(:,10)'* casemult/baseMVA;
% 
% %11
% Pload11=Pd(:,11)'* casemult/baseMVA;
% Qload11=Qd(:,11)'* casemult/baseMVA;
% 
% %12
% Pload12=Pd(:,12)'* casemult/baseMVA;
% Qload12=Qd(:,12)'* casemult/baseMVA;
% 
% %13
% Pload13=Pd(:,13)'* casemult/baseMVA;
% Qload13=Qd(:,13)'* casemult/baseMVA;
% 
% %14
% Pload14=Pd(:,14)'* casemult/baseMVA;
% Qload14=Qd(:,14)'* casemult/baseMVA;
% 
% %15
% Pload15=Pd(:,15)'* casemult/baseMVA;
% Qload15=Qd(:,15)'* casemult/baseMVA;
% 
% %16
% Pload16=Pd(:,16)'* casemult/baseMVA;
% Qload16=Qd(:,16)'* casemult/baseMVA;

% %17
% Pload17=Pd(:,17)'* casemult/baseMVA;
% Qload17=Qd(:,17)'* casemult/baseMVA;
% 
% %18
% Pload18=Pd(:,18)'* casemult/baseMVA;
% Qload18=Qd(:,18)'* casemult/baseMVA;
% 
% %19
% Pload19=Pd(:,19)'* casemult/baseMVA;
% Qload19=Qd(:,19)'* casemult/baseMVA;
% 
% %20
% Pload20=Pd(:,20)'* casemult/baseMVA;
% Qload20=Qd(:,20)'* casemult/baseMVA;
% 
% %21
% Pload21=Pd(:,21)'* casemult/baseMVA;
% Qload21=Qd(:,21)'* casemult/baseMVA;
% 
% %22
% Pload22=Pd(:,22)'* casemult/baseMVA;
% Qload22=Qd(:,22)'* casemult/baseMVA;
% 
% %23
% Pload23=Pd(:,23)'* casemult/baseMVA;
% Qload23=Qd(:,23)'* casemult/baseMVA;
% 
% %24
% Pload24=Pd(:,24)'* casemult/baseMVA;
% Qload24=Qd(:,24)'* casemult/baseMVA;
% 

 %% lines

for iline = 1:numline
   frombus(iline) = branch(iline,1);
   tobus(iline)   = branch(iline,2);
   R(iline)       = branch(iline,3);
   X(iline)       = branch(iline,4);
   Bcap(iline)    = branch(iline,5);
   flowmax(iline) = branch(iline,6);
   BranchStatus(iline) = branch(iline,11);
end
Y = zeros(numbus,numbus);
for iline = 1:numline
    if BranchStatus(iline) == 1
        Y(frombus(iline),tobus(iline)) = Y(frombus(iline),tobus(iline))-1/(R(iline)+sqrt(-1)*X(iline));
        Y(tobus(iline),frombus(iline)) = Y(tobus(iline),frombus(iline))-1/(R(iline)+sqrt(-1)*X(iline));
    end
end
for ibus = 1:numbus
    Y(ibus,ibus) = -sum(Y(ibus,:));
end
for iline = 1:numline
    if BranchStatus(iline) == 1
        Y(frombus(iline),frombus(iline)) = Y(frombus(iline),frombus(iline))+sqrt(-1)*Bcap(iline)/2;
        Y(tobus(iline),tobus(iline)) = Y(tobus(iline),tobus(iline))+sqrt(-1)*Bcap(iline)/2;
    end
end

G=real(Y);
B=imag(Y);

%Init voltage and angle Variables
%v = ones(1,numbus);
%angle = zeros(1,numbus);
v = bus(:,8);
angle = bus(:,9)*(pi/180);
for igen = 1:numgen
    ibus = genbus(igen);
    v(ibus) = Vsched(igen);
end

nbus = numbus;                % Number of buss
ncircuits = numline;               % Number of Interfaces between buss


for iline = 1:numline
   fbus(iline) = frombus(iline);
   tbus(iline) = tobus(iline);
   xckt(iline) = X(iline);
   flowmax_perckt(iline) = flowmax(iline);
   monitor_circuit(iline) = BranchStatus(iline);
end

% end of temp2

    else
        fprintf('No correct case file')
    end
    
end