%% temp 3
% Non-linear Equality and inequality Constrains

function [ineq, ceq]= nonLinConACOPFgeneral(x,Pd,Qd,baseMVA, bus, gen,Y,branch, num_var, Econs)


%% define named indices into data matrices
%from index file functions, see idx_file
[GEN_BUS, PG, QG, QMAX, QMIN, VG, MBASE, GEN_STATUS, PMAX, PMIN, ...
   MU_PMAX, MU_PMIN, MU_QMAX, MU_QMIN, PC1, PC2, QC1MIN, QC1MAX, ...
   QC2MIN, QC2MAX, RAMP_AGC, RAMP_10, RAMP_30, RAMP_Q, APF] = idx_gen;
[F_BUS, T_BUS, BR_R, BR_X, BR_B, RATE_A, RATE_B, RATE_C, ...
   TAP, SHIFT, BR_STATUS, PF, QF, PT, QT, MU_SF, MU_ST, ...
   ANGMIN, ANGMAX, MU_ANGMIN, MU_ANGMAX] = idx_brch;
[PQ, PV, REF, NONE, BUS_I, BUS_TYPE, PD, QD, GS, BS, BUS_AREA, VM, ...
   VA, BASE_KV, ZONE, VMAX, VMIN, LAM_P, LAM_Q, MU_VMAX, MU_VMIN] = idx_bus;


num=1; %timesteps per simulation
%num=length(x)/num_var;






%% build admittance matrices
[Ybus, Yf, Yt] = makeYbus(baseMVA, bus, branch);

  %% find branches with flow limits
il = find(branch(:, RATE_A) ~= 0 & branch(:, RATE_A) < 1e10);
nl2 = length(il);           %% number of constrained lines

%% Find the flow max


  flow_max = (branch(il, RATE_A)/baseMVA).^2;
  flow_max(flow_max == 0) = Inf;
  


%% problem dimensions
nb = size(bus, 1);          %% number of buses
nl = size(branch, 1);       %% number of branches
ng = size(gen, 1);          %% number of dispatchable injections
nxyz = length(x);           %% total number of control vars of all types
%nxyz = nb*4; 


% 1 theta1
% 2 theta2
% 3 theta3
% 4 theta4
% 5 V_1
% 6 V_2
% 7 V_3
% 8 V_4
% 9 P_1
% 10 P_2
% 11 P_3
% 12 P_4
% 13 Q_1
% 14 Q_2
% 15 Q_3
% 16 Q_4


j=1;
k=1;
ceq  = zeros(num*2*nb,1);
ineq = zeros(num*2*nl,1);

%for i=1:num
i=1;
    Vm=x(nb+1+(i-1)*num_var:nb*2+(i-1)*num_var);
    Va=x(1+(i-1)*num_var:nb+(i-1)*num_var);
    Pg=x(nb*2+1+(i-1)*num_var:nb*3+(i-1)*num_var);
    Qg=x(nb*3+1+(i-1)*num_var:nb*4+(i-1)*num_var);
    
    %Qg(3)=0;
    %Pg(3)=x(26+(i-1)*num_var)- x(25+(i-1)*num_var);
    %Pg(3)=x(26+(i-1)*num_var)- x(25+(i-1)*num_var)-Econs(i);


    %% put Pg & Qg back in gen
    
    %gen(:, PG) = Pg * baseMVA;  %% active generation in MW
    %gen(:, QG) = Qg * baseMVA;  %% reactive generation in MVAr
    % changed to this, but that cause problems? Yes, thats not the whole
    % issue! Also fix above; done.
    gen(:, PG) = Pg(1:ng) * baseMVA;  %% active generation in MW
    gen(:, QG) = Qg(1:ng) * baseMVA;  %% reactive generation in MVAr
%     Pg
%     gen(:, PG)
%     gen(:, PG) = Pg(1:nb) * baseMVA;  %% active generation in MW
%     gen(:, QG) = Qg(1:nb) * baseMVA;  %% reactive generation in MVAr

    
    bus(:, PD) = Pd(:,i) ;  %% active generation in MW
    bus(:, QD) = Qd(:,i) ;  %% reactive generation in MVAr


    %% rebuild Sbus
    Sbus = makeSbus(baseMVA, bus, gen); %% net injected power in p.u.

    %% ----- evaluate constraints -----
    %% reconstruct V

    V = Vm .* exp(1j * Va);
    %Ybus * V

    %% evaluate power flow equations
    mis = V .* conj(Ybus * V) - Sbus;

    %%----- evaluate constraint function values -----
    %% first, the equality constraints (power flow)
    g = [ real(mis);            %% active power mismatch for all buses
          imag(mis) ];          %% reactive power mismatch for all buses
      
      ceq(j:length(g)*i,1) =g; 
      %ceq(j:length(g)*i,1) =g*baseMVA; 
      j=j+length(g);

      
        Sf = V(branch(il, F_BUS)) .* conj(Yf * V);  %% complex power injected at "from" bus (p.u.)
        St = V(branch(il, T_BUS)) .* conj(Yt * V);  %% complex power injected at "to" bus (p.u.)
%     if upper(mpopt.opf.flow_lim(1)) == 'P'  %% active power limit, P (Pan Wei)
%       h = [ real(Sf).^2 - flow_max;         %% branch real power limits (from bus)
%             real(St).^2 - flow_max ];       %% branch real power limits (to bus)
%     else                                    %% apparent power limit, |S|
      h = [ Sf .* conj(Sf) - flow_max;      %% branch apparent power limits (from bus)
            St .* conj(St) - flow_max ];    %% branch apparent power limits (to bus)

        
       ineq(k:i*length(h),1) =h; 
      k=k+length(h);
%end

end 