function  [ACOPFsolX, fval] = plotSQGsolutionOfACOPFwSOCinput(parFun,xOut,randTF)

ACOPFcase = parFun{1};
    T = parFun{2};
    
    
        if ACOPFcase ==1
            if randTF == 0
                rRange = 0;
            else
              rRange=parFun{5};
            end
        
        windProjection = parFun{3};
        windMean=parFun{4};
        TotEnBatMax=parFun{6};
        TotEnBat= TotEnBatMax/2;
        
        [Pd, Qd,baseMVA, bus, gen,Y,branch, num_var, Econs, ...
         gencost_inputdata, ...
         Vmax, Vmin, Pmax, Pmin, Qmax, Qmin,...
         numbus, ibus, numgen]=...
        getProblemDataACPOF(ACOPFcase);
        
        ACOPFsolX = zeros(T,numbus*4);
        fval = zeros(T,1);
        %realisedVar = zeros(T,1);
        ACOPFsolXlast=0;
        gradS = zeros(1,T);
        
        for i=1:T
        %[ACOPFsolX(i,:), fval(i), realisedVar(i)] = SimulateACOPF_v02(xOut(i),windProjection(i),windMean(i),rRange,...
        [ACOPFsolX(i,:), fval(i), ACOPFgrad] = SimulateACOPF_v02(xOut(i),windProjection(i),windMean(i),rRange,... 
         Pd, Qd,baseMVA, bus, gen,Y,branch, num_var, Econs, ...
         gencost_inputdata, ...
         Vmax, Vmin, Pmax, Pmin, Qmax, Qmin,...
         numbus, ibus, numgen,...
         TotEnBat, TotEnBatMax,...
         ACOPFsolXlast);
        ACOPFsolXlast=ACOPFsolX(i,:).';
        gradS(i) = ACOPFgrad(numbus*2+1);
        end
        gradS = gradS - mean(gradS)
        
        % Find generated power
%     Pgen      = x_new(9:12)*baseMVA;
%     Qgen      = x_new(13:16)*baseMVA;
    
    Pgen      = ACOPFsolX(:,numbus*2+1:numbus*2+numgen)*baseMVA;
    Qgen      = ACOPFsolX(:,numbus*3+1:numbus*3+numgen)*baseMVA;
    
    PloadIn = zeros(T,numgen);
    QloadIn = ones(T,numgen);
    
    %realisedVar;
    
    SOC0 = TotEnBatMax/2;

    charging = zeros(1,T);
    SOC = [SOC0 xOut]; % [SOCinitial=25 soc1 soc2 soc3 soc4]
    %fval= values(SOC(1),1,RealizedWind(1)); % cost_to_go = inf(Nsoc,T,Nprodw);
    for t =1:T
    %    SOC(t+1) = path(SOC(t),t,RealizedWind(t)); % path = zeros(Nsoc,T,Nprodw);
    %    fval = fval + values(SOC(t),t,RealizedWind(t));
        charging(1,t) = SOC(t+1)-SOC(t);
    end
    
    
    PloadIn(:,2) = charging.';
    %PloadIn(:,2) = xOut.';
    %PloadIn(:,3) = realisedVar;  
    PloadIn(:,4) = Pd(4).*ones(T,1);
    
    for i = 1:T
    QloadIn(i,:) = Qd.';
    end

figure('Name','Generator results','Numbertitle','off');
%c_gen = categorical({'gen1','gen2','gen3'});
gen_vals = [Pgen Qgen];
genfig = plot(gen_vals);
xlabel('Time period')
ylabel('Generated power, P [MW] and Q [MVAr]')
%legend('Gass','Wind','PV')
legend(genfig,'P_{G1,Generator}','P_{G2,Battery}','P_{G3,Wind}','P_{G4,Household}','Q_{G1,Generator}','Q_{G2,Battery}','Q_{G3,Wind}','Q_{G4,Household}')
%legend('Active power, P [MW]','Reactive power, Q [MVAr]')
if randTF == 0
    title('Active power (P) and reactive power (Q) for the generators with no randomness')
    saveas(gcf,'GenRand0.fig');
    saveas(gcf,'GenRand0.png');
else
    title('Active power (P) and reactive power (Q) for the generators with randomness')
    saveas(gcf,'GenRand1.fig');
    saveas(gcf,'GenRand1.png');
end



% 
figure('Name','Load demand','Numbertitle','off');
% c_load = categorical({'P1','P2','P3'});
% Ploads = [Ploa1 Ploa2 Ploa3 Ploa4]
%c_load = categorical({'Business','Household','Battery'});
Ploads = [PloadIn QloadIn];
loadfig=plot(Ploads);
xlabel('Time period')
ylabel('Load values, P [MW] and Q [MVAr]')
legend(loadfig,'P_{L1,Generator}','P_{L2,Battery}','P_{L3,Wind}','P_{4,Household}','Q_{1,Generator}','Q_{2,Battery}','Q_{3,Wind}','Q_{4,Household}')
%legend('Active power, P [MW]','Reactive power, Q [MVAr]')
if randTF == 0
    title('Active power (P) and reactive power (Q) demand for the bus loads with no randomness')
    saveas(gcf,'LoadRand0.fig');
    saveas(gcf,'LoadRand0.png');
else
  title('Active power (P) and reactive power (Q) demand for the bus loads with randomness')
  saveas(gcf,'LoadRand1.fig');
  saveas(gcf,'LoadRand1.png');
end

SOC(2:T+1)
charging
        
    elseif ACOPFcase == 2
        if randTF == 0
            rRange=[0 0 0 0 0 0 0 0 0];
        else
            rRange=parFun{5};
        end
    %rRange=[0 0 0 0 0 0 0 0 0];

[Pd, Qd,Pg, Qg,baseMVA, bus, gen,Y,branch, num_var, Econs, ...
     gencost_inputdata, ...
    Vmax, Vmin, Pmax, Pmin, Qmax, Qmin,...
    numbus, ibus, numgen]=...
        getProblemDataACPOF2(ACOPFcase);
    
    
    
    ACOPFsolX = zeros(T,numbus*4);
    fval = zeros(T,1);
    realisedVar = zeros(T,numbus);
    ACOPFsolXlast = 0;
    
    gradS = zeros(1,T);
    
    plotResults = 1;
    
    for i=1:T
        [ACOPFsolX(i,:), fval(i), ACOPFgrad, realisedVar(i,:)] = SimulateACOPF_v03(xOut(i),rRange,...
            Pd(:,i), Qd(:,i),Pg(:,i), Qg(:,i),baseMVA, bus, gen,Y,branch, num_var, Econs, ...
            gencost_inputdata, ...
            Vmax, Vmin, Pmax, Pmin, Qmax, Qmin,...
            numbus, ibus, numgen,...
            ACOPFsolXlast.',plotResults);
        ACOPFsolXlast=ACOPFsolX(i,:);
        gradS(i) = ACOPFgrad(numbus*2+1);
    end
    RMS_gradP = sqrt(mean(gradS.^2));
    gradSOC = gradS - RMS_gradP
    

    %update control variable values
% 1 theta1
% 2 theta2
% 3 theta3
% 4 theta4
% 5 V_1
% 6 V_2
% 7 V_3
% 8 V_4
% 9 P_1
% 10 P_2
% 11 P_3
% 12 P_4
% 13 Q_1
% 14 Q_2
% 15 Q_3
% 16 Q_4

%     %% ----- evaluate constraints -----
%     %first display resulting V and angle
%     v_out = stateVar(5:8)*baseKV
%     angle_out = stateVar(1:4)*(pi/180)
%      
% %     %evaluate
% %     Vm_out = x_new(5:8);
% %     Va_out = x_new(1:4);
% %     
% %     % reconstruct V
% %     V = Vm_out .* exp(1j * Va_out);
% %     % evaluate power flow equations
% %     [Ybus, Yf, Yt] = makeYbus(baseMVA, bus, branch);
% %     Sbus = makeSbus(baseMVA, bus, gen)
% %     %resulteing injections
% %     S = V .* conj(Ybus * V)*baseMVA
%     %diff is ceq
%     %DiffPowerFlow = [ceq(1:4) ceq(5:8)]*baseMVA
%  % ----  Find generated power
%    Pbus      = ACOPFsolX(:,numbus*2+1:numbus*3)*baseMVA;
%    Qbus      = ACOPFsolX(:,numbus*3+1:numbus*4)*baseMVA;
    
    %realisedVar

    Pgen      = ACOPFsolX(:,numbus*2+1:numbus*2+numgen-1)*baseMVA;
    Qgen      = ACOPFsolX(:,numbus*3+1:numbus*3+numgen-1)*baseMVA;
    
    PloadIn = zeros(T,3);
    QloadIn = zeros(T,3);
    
    PloadIn(:,1) = realisedVar(:,5);
    PloadIn(:,2) = realisedVar(:,7);
    
    TotEnBatMax=parFun{6};
    SOC0 = TotEnBatMax/2;

    charging = zeros(1,T);
    SOC = [SOC0 xOut]; % [SOCinitial=25 soc1 soc2 soc3 soc4]
    %fval= values(SOC(1),1,RealizedWind(1)); % cost_to_go = inf(Nsoc,T,Nprodw);
    for t =1:T
    %    SOC(t+1) = path(SOC(t),t,RealizedWind(t)); % path = zeros(Nsoc,T,Nprodw);
    %    fval = fval + values(SOC(t),t,RealizedWind(t));
        charging(1,t) = SOC(t+1)-SOC(t);
    end
    
    
    PloadIn(:,3) = charging.';
    %PloadIn(:,3) = xOut.';
    
    QloadIn(:,1) = realisedVar(:,5+1);
    QloadIn(:,2) = realisedVar(:,7+1);
    
%     PloadIn(:,1) = Pd(5,:).';
%     PloadIn(:,2) = Pd(7,:).';
%     PloadIn(:,3) = xOut.';
%     
%     QloadIn(:,1) = Qd(5,:).';
%     QloadIn(:,2) = Qd(7,:).';
%     
% %     Ploa1     = Pd(1);
% %     Ploa2     = Pd(2);
% %     Ploa3     = Pd(3);
% %     Ploa4     = Pd(4);
%     
% %     
% %     for i=1:length(x_new)/num_var
% %         State_ofC(i)= x_new(21+(i-1)*26)*baseMVA;
% %         gen1(i)=x_new(19+(i-1)*26)*baseMVA;
% %         gen2(i)=x_new(20+(i-1)*26)*baseMVA;
% %         charge(i)=x_new(25+(i-1)*26)*baseMVA;
% %         discharge(i)=x_new(26+(i-1)*26)*baseMVA;
% %         Ploa1(i)=Pd(5,i);
% %         Ploa2(i)=Pd(7,i);
% %         Ploa3(i)=Pd(9,i);
% %     end
% 
figure('Name','Generator results','Numbertitle','off');
%c_gen = categorical({'gen1','gen2','gen3'});
gen_vals = [Pgen Qgen];
genfig = plot(gen_vals);
xlabel('Time period')
ylabel('Generated power, P [MW] and Q [MVAr]')
%legend('Gass','Wind','PV')
legend(genfig,'P_{Gass}','P_{Wind}','P_{PV}','Q_{Gass}','Q_{Wind}','Q_{PV}')
%legend('Active power, P [MW]','Reactive power, Q [MVAr]')
if randTF == 0
    title('Active power (P) and reactive power (Q) for the generators with no randomness')
    saveas(gcf,'GenRand0.fig');
    saveas(gcf,'GenRand0.png');
else
    title('Active power (P) and reactive power (Q) for the generators with randomness')
    saveas(gcf,'GenRand1.fig');
    saveas(gcf,'GenRand1.png');
end

% 
figure('Name','Load demand','Numbertitle','off');
% c_load = categorical({'P1','P2','P3'});
% Ploads = [Ploa1 Ploa2 Ploa3 Ploa4]
%c_load = categorical({'Business','Household','Battery'});
Ploads = [PloadIn QloadIn];
loadfig=plot(Ploads);
xlabel('Time period')
ylabel('Load values, P [MW] and Q [MVAr]')
legend(loadfig,'P_{Business}','P_{Household}','P_{Battery}','Q_{Business}','Q_{Household}','Q_{Battery}')
%legend('Active power, P [MW]','Reactive power, Q [MVAr]')
%title('Active power (P) and reactive power (Q) demand for the bus loads')
if randTF == 0
    title('Active power (P) and reactive power (Q) demand for the bus loads with no randomness')
    saveas(gcf,'LoadRand0.fig');
    saveas(gcf,'LoadRand0.png');
else
  title('Active power (P) and reactive power (Q) demand for the bus loads with randomness')
  saveas(gcf,'LoadRand1.fig');
  saveas(gcf,'LoadRand1.png');
end

    else
          fprintf('Plot-case not defined');
    end
end