
function [ACOPFsolX, fval] = testACOPFcase9T1(x0,parFun)
close all 

% Argument management:
% parFun and x0 is optional,
% but x0 is desired
if nargin < 2
   rRange = [0 0.25 0.10 0 0.05 0 0.10 0 0];
   caseData = 2;
   if nargin == 1
    x0 = ones(1,24)*x0;
   end
else
    rRange=parFun{5};
    caseData = parFun{1};
end
if nargin < 1
   x0 = [100	90	80	70	60	40	-20	-50	-80	-70	-40	-30	-30	-30	-50	-70	-60	-50	0	50	70	80	90	100];
end

%rRange=parFun{5};

[Pd, Qd,Pg, Qg,baseMVA, bus, gen,Y,branch, num_var, Econs, ...
     gencost_inputdata, ...
    Vmax, Vmin, Pmax, Pmin, Qmax, Qmin,...
    numbus, ibus, numgen]=...
            getProblemDataACPOF2(caseData);
%        getProblemDataACPOF2(parFun{1});
%numbus
% Pd 
% Qd
% Pg
% Qg
ACOPFsolX = 0;
plotResults = 0;

    i =11;
     %x0
% rRange
tic;
    [ACOPFsolX, fval, grad, realisedVar] = SimulateACOPF_v03(x0(i),rRange,...
            Pd(:,i), Qd(:,i),Pg(:,i), Qg(:,i),baseMVA, bus, gen,Y,branch, num_var, Econs, ...
            gencost_inputdata, ...
            Vmax, Vmin, Pmax, Pmin, Qmax, Qmin,...
            numbus, ibus, numgen,...
            ACOPFsolX, plotResults);
        realisedVar
%         Pmax
%         Pmin
%         Qmax
%         Qmin
        %  % ----  Find generated power
%    Pbus      = ACOPFsolX(:,numbus*2+1:numbus*3)*baseMVA;
%    Qbus      = ACOPFsolX(:,numbus*3+1:numbus*4)*baseMVA;
    
    Pgen      = ACOPFsolX(:,numbus*2+1:numbus*2+numgen-1)*baseMVA;
    Qgen      = ACOPFsolX(:,numbus*3+1:numbus*3+numgen-1)*baseMVA;
    
    PloadIn = zeros(1,3);
    QloadIn = zeros(1,3);
    
    PloadIn(1) = realisedVar(5);
    PloadIn(2) = realisedVar(7);
    PloadIn(3) = x0(i);
    
    QloadIn(1) = realisedVar(5+1);
    QloadIn(2) = realisedVar(7+1);
%     
% %     Ploa1     = Pd(1);
% %     Ploa2     = Pd(2);
% %     Ploa3     = Pd(3);
% %     Ploa4     = Pd(4);
%     
% %     
% %     for i=1:length(x_new)/num_var
% %         State_ofC(i)= x_new(21+(i-1)*26)*baseMVA;
% %         gen1(i)=x_new(19+(i-1)*26)*baseMVA;
% %         gen2(i)=x_new(20+(i-1)*26)*baseMVA;
% %         charge(i)=x_new(25+(i-1)*26)*baseMVA;
% %         discharge(i)=x_new(26+(i-1)*26)*baseMVA;
% %         Ploa1(i)=Pd(5,i);
% %         Ploa2(i)=Pd(7,i);
% %         Ploa3(i)=Pd(9,i);
% %     end
% 
% figure('Name','Generator results','Numbertitle','off');
% %c_gen = categorical({'gen1','gen2','gen3'});
% gen_vals = [Pgen Qgen];
% genfig = plot(gen_vals);
% xlabel('Generator')
% ylabel('Generated power, P [MW] and Q [MVAr]')
% %legend('Gass','Wind','PV')
% legend(genfig,'P_{Gass}','P_{Wind}','P_{PV}','Q_{Gass}','Q_{Wind}','Q_{PV}')
% %legend('Active power, P [MW]','Reactive power, Q [MVAr]')
% title('Active power (P) and reactive power (Q) for the generators')
% % 
% figure('Name','Load demand','Numbertitle','off');
% % c_load = categorical({'P1','P2','P3'});
% % Ploads = [Ploa1 Ploa2 Ploa3 Ploa4]
% %c_load = categorical({'Business','Household','Battery'});
% Ploads = [PloadIn QloadIn];
% loadfig=plot(Ploads);
% xlabel('Bus number')
% ylabel('Load values, P [MW] and Q [MVAr]')
% legend(loadfig,'P_{Business}','P_{Household}','P_{Battery}','Q_{Business}','Q_{Household}','Q_{Battery}')
% %legend('Active power, P [MW]','Reactive power, Q [MVAr]')
% title('Active power (P) and reactive power (Q) demand for the bus loads')
        
%% Figures        

figure('Name','Generator results','Numbertitle','off');
%c_gen = categorical({'Gass','Wind','PV'});
gen_vals = [Pgen.' Qgen.'];
%bar(c_gen,gen_vals);
bar(gen_vals);
set(gca,'xticklabel',{'Gass','Wind','PV'});
xlabel('Generator')
ylabel('Generated power');
legend('Active power, P [MW]','Reactive power, Q [MVAr]');
title('Results for the generators');

figure('Name','Load demand','Numbertitle','off');
% c_load = categorical({'P1','P2','P3','P4'});
% Ploads = [Ploa1 Ploa2 Ploa3 Ploa4]
%c_load = categorical({'Business','Household','Battery'});
Ploads = [PloadIn.' QloadIn.'];
%bar(c_load,Ploads)
bar(Ploads);
set(gca,'xticklabel',{'Business','Household','Battery'});
xlabel('Demand bus');
ylabel('Load values');
legend('Active power, P [MW]','Reactive power, Q [MVAr]');
title('Demand for the bus loads');

[ineq, ceq]= nonLinConACOPFgeneral(ACOPFsolX.',Pd,Qd,baseMVA, bus, gen,bus,branch, num_var, Econs)

Pbal = [sum(Pgen) sum(PloadIn)]
Qbal = [sum(Qgen) sum(QloadIn)]
end