%% Simple 4 bus case as illustration and starting point
%  See fiugre for picture and parameters
%  ----------------------------------------------------
%%
close all
clear
clc

%% Total number of varibles in 1 hour for 4 busses
% 1 theta1
% 2 theta2
% 3 theta3
% 4 theta4
% 5 V_1
% 6 V_2
% 7 V_3
% 8 V_4
% 9  P_1 - Pgen
% 10 P_2 - Pw
% 11 P_3 - Pbat
% 12 P_4 - Pl
% 13 Q_1
% 14 Q_2
% 15 Q_3
% 16 Q_4

n=4;
num_var = 16;

z_w = 0.5 + 1i*0.3;
z_g = 0.3 + 1i*0.2;
z_bl = 0.2 + 1i*0.1;

y_w = 1/z_w ;
y_g = 1/z_g ;
y_bl = 1/z_bl ;

%Ybus=zeros(n);
Ybus = [y_g+y_g+y_w     -y_w            -y_g        -y_g;
        -y_w            y_w+y_w+y_w     -y_w        -y_w;
        -y_g            -y_w       y_g+y_w+y_bl     -y_bl;
        -y_g            -y_w            -y_bl       y_g+y_w+y_bl];
%G=real(Ybus);
%B=imag(Ybus);



%[x,fval,exitflag,output,lambda,grad,hessian] = fmincon(fun,x0,A,b,Aeq,beq,lb,ub,nonlcon,options);
Vbase = 10;
Cgen = 50;

%least cost pgen
Pg_leastcost = 80;
Qg_leastcost = 20;

%cost function; deviation from Pg_least
fCost = @(x) (x(9)-Pg_leastcost)^2*Cgen; %Pgen-80

%Pw is guess of wind energy
Pw = 40;
Qw = 0;
% loads Pl  Ql
Pl = -100;
Ql = -20;
%bat
Pb = -Pl-Pw-Pg_leastcost;
%Qb = -Ql-Qw-Qg_leastcost;
Qb = 0;

% P_1 - Pgen, P_2 - Pw, P_3 - Pbat, P_4 - Pl
%Aeg*x = beq
%beq = [V1  delta1  Pl  Ql  Pw  Qw  Pb  Vb];
%beq = [Vbase 0      Pl  Ql  Pw  Qw  Pb Vbase].';
beq = [Vbase 0      Pl  Ql  Pw  Qw  Pb Qb].';
% x = [d1   d2  d3  d4  v1  v2  v3  v4  P1  P2  P3  P4  Q1  Q2  Q3  Q4]
Aeq = [0    0   0   0   1   0   0   0   0   0   0   0   0   0   0   0;
       1    0   0   0   0   0   0   0   0   0   0   0   0   0   0   0;
       0    0   0   0   0   0   0   0   0   0   0   1   0   0   0   0;
       0    0   0   0   0   0   0   0   0   0   0   0   0   0   0   1;
       0    0   0   0   0   0   0   0   0   1   0   0   0   0   0   0;
       0    0   0   0   0   0   0   0   0   0   0   0   0   1   0   0;
       0    0   0   0   0   0   0   0   0   0   1   0   0   0   0   0;
       0    0   0   0   0   0   0   0   0   0   0   0   0   0   1   0];
%  beq = []; 
%  Aeq = [];

%%b = [Iij,rated * yij] for all 6 lines
%Iij_rated = Vbase*0.6/max(max(abs(Ybus)));
%b = Iij_rated *[abs(Ybus(1,2)) abs(Ybus(1,3)) abs(Ybus(1,4)) abs(Ybus(2,3)) abs(Ybus(2,4)) abs(Ybus(3,4))];
%%A = [Vi  -Vj] for all 6 lines (ish)
% x = [d1   d2  d3  d4  v1  v2  v3  v4  P1  P2  P3  P4  Q1  Q2  Q3  Q4]
% A   = [0    0   0   0   1   -1   0   0   0   0   0   0   0   0   0   0;
%        0    0   0   0   1   0   -1   0   0   0   0   0   0   0   0   0;
%        0    0   0   0   1   0   0   -1   0   0   0   0   0   0   0   0;
%        0    0   0   0   0   1   -1   0   0   0   0   0   0   0   0   0;
%        0    0   0   0   0   1   0   -1   0   0   0   0   0   0   0   0;
%        0    0   0   0   0   0   1   -1   0   0   0   0   0   0   0   0];
   

Vmx = Vbase*1.1;
Vmn = Vbase*0.9;
Pbase = 100;
Pg_mx = -Pw-Pl-Pb+15;
Pg_mn  = -Pw-Pl-Pb;
Qg_mx = -Qw-Ql-Qb+15;
Qg_mn = -Qw-Ql-Qb;
dmn = -pi()/2;
dmx = pi()/2;

% P_1 - Pgen, P_2 - Pw, P_3 - Pbat, P_4 - Pl
%lb & ub given for X
% x = [d1   d2  d3  d4  v1  v2  v3  v4  P1    P2  P3  P4  Q1  Q2  Q3 'Q4]
lb =  [0  dmn dmn dmn Vbase Vmn Vmn Vmn Pg_mn Pw  Pb  Pl  Qg_mn Qw Qb Ql].';
ub =  [0  dmx dmx dmx Vbase Vmx Vmx Vmx Pg_mx Pw  Pb  Pl  Qg_mx Qw Qb Ql].';
%x0 = zeros(num_var,1);

x0=lb+(ub-lb)/2;
%x0(isnan(x0))=0;
%lb = [];
%ub = [];
%x0 = [0 0 0 0  10 10 10 10 80 30 -10 -100 20 0 0 -20].';



A = [];
b = [];
nonlcon = @(x)powerflowConst(x,Ybus);



options = optimoptions('fmincon','Display','iter-detailed','MaxIter',2000,'MaxFunEvals',600000,'TolCon',1e-10,'TolX',1e-12);

%options = optimoptions('fmincon','Algorithm','sqp','Display','iter-detailed','MaxIter',1000,'MaxFunEvals',600000,'TolCon',1e-10,'TolX',1e-12);

tic
[x,fval,exitflag,output,lambda,grad,hessian] = fmincon(fCost,x0,A,b,Aeq,beq,lb,ub,nonlcon,options);
toc
diffAx_b = Aeq*x - beq
[c, ceq] = powerflowConst(x,Ybus);
ceq
x
fval
MW = x(9:12)
MVAr = x(13:16)

